using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using XNode;
//using plugpea;
using System;
using System.Linq;
using UnityEditor;

using Unity.VisualScripting;

using PlugPeaNodes;
using Plane = PlugPeaNodes.Plane;
using System.Numerics;
using Vector3 = UnityEngine.Vector3;
using Quaternion = UnityEngine.Quaternion;
using Node = XNode.Node;
using Slider = PlugPeaNodes.Slider;
using System.Drawing;
using Color = UnityEngine.Color;
using UnityEditor.Experimental.GraphView;
using XNodeEditor;
using static Unity.VisualScripting.Metadata;
using UnityEngine.UI;
using Newtonsoft.Json.Linq;
using FontStyle = UnityEngine.FontStyle;
using JetBrains.Annotations;
using UnityEngine.XR;
using static System.Net.Mime.MediaTypeNames;
namespace plugpea
{
    [ExecuteInEditMode]
    public class PlugPea : MonoBehaviour
    {

        [HideInInspector]
        public List<string> sliderNames;
        [HideInInspector]
        public List<float> sliderValues;
        [HideInInspector]
        public bool enableEditing = false;

        [HideInInspector]
        public bool detachedGraph = false;
        //[HideInInspector]
        public PlugPeaGraph graph;


        [HideInInspector]
        public float pointSize = 4f;

        [HideInInspector]
        public float PlaneSize = 4f;

        //public string id;

        [HideInInspector]
        public static float PointSizePreview;
        [HideInInspector]
        public List<List<Vector3>> points = new List<List<Vector3>>();

        //  public float planesize = 12f;
        [HideInInspector]
        public bool positionBinde = true;


        public IDictionary<int, List<Vector3>> pointDictPreview = new Dictionary<int, List<Vector3>>();
        public IDictionary<int, List<Curve>> curveDictPreview = new Dictionary<int, List<Curve>>();
        public IDictionary<int, List<Plane>> planeDictPreview = new Dictionary<int, List<Plane>>();
        public IDictionary<int, List<Mesh>> meshDictPreview = new Dictionary<int, List<Mesh>>();

        //wf

        public IDictionary<int, bool> pointDictPreviewBool = new Dictionary<int, bool>();
        public IDictionary<int, bool> curveDictPreviewBool = new Dictionary<int, bool>();
        public IDictionary<int, bool> planeDictPreviewBool = new Dictionary<int, bool>();
        [SerializeField]

        //public List<int> point_DictPreviewBool_Indices = new List<int>();
        //public List<int> curve_DictPreviewBool_Indices = new List<int>();
        [HideInInspector]
        public List<int> DictPreviewBool_Indices = new List<int>();
        //public List<int> plane_DictPreviewBool_Indices = new List<int>();

        public IDictionary<int, bool> meshDictPreviewBool = new Dictionary<int, bool>();
        List<InputNode> inputNodes = new List<InputNode>();
        PlugPeaGraph instanceGraph;
        [HideInInspector]
        public bool child = false;
        [HideInInspector]
        public GUID objectGUID;
        [HideInInspector]
        public string guidString;

        // Other code or functionality associated with the object
        [SerializeField]
        [HideInInspector]
        public string Id;
        //efww
        //[SerializeField]
        //[HideInInspector]
        //public string privateId;
        [HideInInspector]
        [SerializeField]
        
        public string privateId;



        public void Awake()
        {

            //pointDictPreview = new Dictionary<int, List<Vector3>>();
            //curveDictPreview = new Dictionary<int, List<Curve>>();
            //planeDictPreview = new Dictionary<int, List<Plane>>();
            //meshDictPreview = new Dictionary<int, List<Mesh>>();


            //ef
            //pointDictPreviewBool = new Dictionary<int, bool>();
            //curveDictPreviewBool = new Dictionary<int, bool>();
            //planeDictPreviewBool = new Dictionary<int, bool>();
            //meshDictPreviewBool = new Dictionary<int, bool>();
            if (objectGUID.Empty())
            {
                objectGUID = GUID.Generate();
                Id = GUIDManager.ExtractDigits(objectGUID.ToString());

            }
            //wfe

            //if (string.IsNullOrEmpty(privateId))//
            //{
            //var ee = GUID.Generate();
            //var ee = UniqueIDGenerator.GetUniqueID(gameObject);
            //privateId = GUIDManager.ExtractDigits(ee.ToString());
            var ee = GUID.Generate();
            privateId = GUIDManager.ExtractDigits(ee.ToString());
            //UnityEditor.EditorUtility.SetDirty(this); // Mark the ScriptableObject as dirty to save changes.

            ///  }


            lock (GUIDManager.plugpeaDictionaryID)
            {
                //ef
                if (!GUIDManager.plugpeaDictionaryID.ContainsKey(Id))
                {

                    GUIDManager.plugpeaDictionaryID.Add(Id, this);
                }
                else
                {
                    GUIDManager.plugpeaDictionaryID[Id] = (PlugPea)this;

                }

            }



        }



        public void detached()
        {
            if (graph == null)
            {
                return;
            }
            string folderPath = "Assets/PlugPea Graphs";

            string graphName = this.gameObject.name;
            graph.childIDs.Remove(Id);
            objectGUID = GUID.Generate();
            Id = GUIDManager.ExtractDigits(objectGUID.ToString());

            meshDictPreview = new Dictionary<int, List<Mesh>>();
            curveDictPreview = new Dictionary<int, List<Curve>>();
            pointDictPreview = new Dictionary<int, List<Vector3>>();
            planeDictPreview = new Dictionary<int, List<Plane>>();
            //yg
            var graphs = CustomGameObjectPreset.createGraph(folderPath, graphName, this.gameObject, graph);

            graphs.currentGameobject = (GameObject)this.gameObject;
            graphs.currentGameobjectString = this.gameObject.name;
            graphs.plugpeaGUID = objectGUID;

            //graphs.plugpeaID = Id;
            child = false;
            graph = graphs;

            meshDictPreview = graph.meshDictPreview;
            curveDictPreview = graph.curveDictPreview;
            pointDictPreview = graph.pointDictPreview;
            planeDictPreview = graph.planeDictPreview;
        }

        public void OnEnable()
        {
            //previous awake

            ////
            //meshDictPreview.Clear();
            //curveDictPreview.Clear();
            //pointDictPreview.Clear();s
            //planeDictPreview.Clear();

            //ef



            lock (GUIDManager.plugpeaDictionaryID)
            {
                if (!GUIDManager.plugpeaDictionaryID.ContainsKey(Id))
                {
                    GUIDManager.plugpeaDictionaryID.Add(Id, this);
                }
                else
                {
                    GUIDManager.plugpeaDictionaryID[Id] = (PlugPea)this;

                }
            }
            if (graph == null) return;

            if (graph != null)
            {
                meshDictPreview = graph.meshDictPreview;
                curveDictPreview = graph.curveDictPreview;
                pointDictPreview = graph.pointDictPreview;
                planeDictPreview = graph.planeDictPreview;
                //Debug.Log(graph.plugpeaID);
                //Debug.Log(Id);
                if (string.IsNullOrEmpty(graph.plugpeaID))
                {
                    graph.plugpeaID = Id;
                    Debug.Log("it the first time");
                    child = false;
                }

                if (graph.plugpeaID != Id)
                {
                    //if (graph.plugpeaID == null)
                    //{
                    //    objectGUID = GUID.Generate();e
                    //    Id = GUIDManager.ExtractDigits(objectGUID.ToString());
                    //    graph.plugpeaID = Id;

                    //}

                    string ds = GUIDManager.plugpeaDictionaryID.FirstOrDefault(x => x.Value == this).Key;
                    GUIDManager.plugpeaDictionaryID.Remove(ds);

                    Id = graph.plugpeaID;
                    lock (GUIDManager.plugpeaDictionaryID)
                    {
                        if (GUIDManager.plugpeaDictionaryID.ContainsKey(Id))
                        {
                            PlugPea testPP = GUIDManager.plugpeaDictionaryID[Id];
                            if (testPP == null)
                            {
                                GUIDManager.plugpeaDictionaryID.Add(Id, (PlugPea)this);
                            }
                        }

                    }
                    child = true;


                }

                foreach (Node b in graph.nodes)
                {
                    if (b is InputNode inputnode)
                    {

                        if (inputnode is Slider slider)
                        {

                            slider.OnInputValueChanged += HandleInputValueChanged;
                            inputNodes.Add(slider);
                        }
                    }

                }



            }


            if (!graph.childIDs.Contains(privateId))
            {
                graph.childIDs.Add(privateId);
                graph.childNames.Add(gameObject.name);

            }

            else
            {
                if (graph.childNames[graph.childIDs.IndexOf(privateId)] != gameObject.name)
                {
                    var ee = GUID.Generate();
                    privateId = GUIDManager.ExtractDigits(ee.ToString());

                    graph.childIDs.Add(privateId);
                    graph.childNames.Add(gameObject.name);
                }
            }


        }



        public void updateAll()
        {
            //get 



            if (graph != null)
            {

                if (graph.plugpeaID == null)
                {

                    objectGUID = GUID.Generate();
                    Id = GUIDManager.ExtractDigits(objectGUID.ToString());
                    graph.plugpeaID = Id;
                }
                //e
                //meshDictPreview.Clear();
                //curveDictPreview.Clear();
                //pointDictPreview.Clear();
                //planeDictPreview.Clear();
                graph.plugpeaID = Id;
                //graph.currentGameobject = this.gameObject;ef
                foreach (Node n in graph.nodes)
                {

                    if (n is BaseNode bb)
                    {
                        graph.UpdateLogic(bb, graph);

                    }
                }

            }
        }
        private int GenerateUniqueID()
        {
            // Generate a unique ID using a combination of current time and instance ID
            string uniqueString = DateTime.Now.Ticks.ToString() + GetInstanceID().ToString();
            int uniqueID = uniqueString.GetHashCode();
            return uniqueID;
        }
        string systemName;
        #region
        public void UpdateLogicOld(BaseNode b, PlugPeaGraph graph)
        {

            PlugPeaGraph nodeGraphChecker = b.graph as PlugPeaGraph;

            if (!(nodeGraphChecker.plugpeaID == this.Id || nodeGraphChecker.childIDs.Contains(Id))) { return; } //detachedGraph==true &&
            int nodeId = b.GetInstanceID();


            graph.current = (BaseNode)b;
            // b.GetString();  
            if (graph.current != null)
            {
                if (graph.current.GetString() == "Draw")
                {

                    object input;
                    var inputType = "null";
                    try
                    {
                        NodePort p = b.Outputs.First();
                        input = graph.current.GetValue(p);
                        inputType = input.GetType().ToString();
                    }
                    catch
                    {
                        NodePort p = b.Ports.First();
                        input = graph.current.GetValue(p);


                    }


                    switch (inputType)
                    {

                        case "System.Collections.Generic.List`1[PlugPeaNodes.Plane]":

                            List<Plane> inputPlane = (List<Plane>)input;
                            List<Plane> tempPlane = new List<Plane>();
                            foreach (var plane in inputPlane)
                            {

                                tempPlane.Add(plane);
                            }
                            if (planeDictPreview.ContainsKey(nodeId))
                            {
                                planeDictPreview[nodeId] = tempPlane;

                            }
                            else
                            {
                                planeDictPreview.Add(nodeId, tempPlane);
                            }

                            break;


                        case "System.Collections.Generic.List`1[PlugPeaNodes.Curve]":
                            List<Curve> inputCurve = (List<Curve>)input;
                            List<Curve> tempCurve = new List<Curve>();
                            foreach (var curve in inputCurve)
                            {

                                tempCurve.Add(curve);
                            }
                            if (curveDictPreview.ContainsKey(nodeId))
                            {
                                curveDictPreview[nodeId] = tempCurve;
                            }
                            else
                            {
                                curveDictPreview.Add(nodeId, tempCurve);
                            }

                            break;

                        case "System.Collections.Generic.List`1[UnityEngine.Mesh]":
                            List<Mesh> inputMesh = (List<Mesh>)input;
                            List<Mesh> tempMesh = new List<Mesh>();
                            foreach (var mesh in inputMesh)
                            {

                                tempMesh.Add(mesh);
                            }
                            if (meshDictPreview.ContainsKey(nodeId))
                            {
                                meshDictPreview[nodeId] = tempMesh;

                            }
                            else
                            {
                                meshDictPreview.Add(nodeId, tempMesh);
                            }

                            break;

                        case "System.Collections.Generic.List`1[Vector3]":
                            List<Vector3> inputPoints = (List<Vector3>)input;
                            List<Vector3> tempPoints = new List<Vector3>();
                            foreach (var point in inputPoints)
                            {

                                tempPoints.Add(point);
                            }
                            if (pointDictPreview.ContainsKey(nodeId))
                            {
                                pointDictPreview[nodeId] = tempPoints;

                            }
                            else
                            {
                                pointDictPreview.Add(nodeId, tempPoints);
                            }

                            break;
                        case "System.Collections.Generic.List`1[UnityEngine.Vector3]":
                            List<Vector3> inputPointss = (List<Vector3>)input;
                            List<Vector3> tempPointss = new List<Vector3>();
                            foreach (var point in inputPointss)
                            {

                                tempPointss.Add(point);
                            }
                            if (pointDictPreview.ContainsKey(nodeId))
                            {
                                pointDictPreview[nodeId] = tempPointss;

                            }
                            else
                            {
                                pointDictPreview.Add(nodeId, tempPointss);
                            }

                            break;
                        case "null":
                            break;


                        //// Add other cases as required...
                        default:
                            //Debug.LogWarning($"Unsupported type {inputType} in ListItemNode.");   //Enable to debug
                            break;
                    }


                }

                else if (graph.current.GetString() == "Slider")
                {
                    NodePort p = b.Outputs.First();
                    graph.current.GetValue(p);
                }
                //else if (graph.current.GetString() == "Pointss")
                //{
                //    NodePort p = b.Outputs.First();
                //    List<Vector3> input = (List<Vector3>)graph.current.GetValue(p);
                //    bool ee = null;

                //    bool isEnabled = ee.enabled;
                //    int id = ee.id;
                //    string nodeName = graph.current.name;
                //    string name = id.ToString();
                //    string idString = id.ToString();
                //    string alternateName = idString.Substring(1, 3) + " Points";
                //    if (nodeName != "Points")
                //    {
                //        name = nodeName;
                //    }
                //    else
                //    {

                //        name = alternateName;
                //    }


                //    GameObject existingObject = GameObject.Find(name);
                //    if (existingObject == null)
                //    {
                //        existingObject = GameObject.Find(alternateName);
                //        if (existingObject != null)
                //        {
                //            existingObject.name = name;
                //        }

                //    }
                //    if (existingObject == null)
                //    {
                //        GameObject newObject = new GameObject(name);
                //        newObject.transform.SetParent(gameObject.transform, false);
                //        pointPreviewAndEdit pointTopreview = newObject.AddComponent<pointPreviewAndEdit>();

                //        if (input.Count >= 0)
                //        {
                //            for (int i = 0; i < input.Count; i++)
                //            {

                //                pointTopreview.points.Add(input[i]);
                //            }

                //        }


                //    }


                //    else
                //    {

                //        // If the game object already exists, update the mesh
                //        if (input != null)
                //        {
                //            if (input.Count > 0)
                //            {

                //                pointPreviewAndEdit pointTopreview = existingObject.GetComponent<pointPreviewAndEdit>();
                //                pointTopreview.isEnabled = ee.enabled;
                //                if (input.Count == pointTopreview.points.Count)
                //                {
                //                    for (int i = 0; i < input.Count; i++)
                //                    {
                //                        input[i] = pointTopreview.points[i];
                //                    }
                //                }
                //                else
                //                {
                //                    if (input.Count > pointTopreview.points.Count)
                //                    {


                //                        pointTopreview.points.Add(input[pointTopreview.points.Count]);


                //                    }
                //                    else
                //                    {
                //                        pointTopreview.points.RemoveAt(pointTopreview.points.Count - 1);
                //                    }

                //                }

                //            }
                //        }



                //    }

                //}
                else if (graph.current.GetString() == "Panel")
                {
                    NodePort p = b.Ports.First();
                    graph.current.GetValue(p);
                }
                else if (graph.current.GetString() == "ExportMesh2")
                {

                    int id = graph.current.GetInstanceID();
                    string nodeName = graph.current.name;
                    string name = id.ToString();
                    string previousName = null;

                    if (nodeName == "Mesh Export")
                    {
                        string idString = id.ToString();
                        name = idString.Substring(1, 3) + " Mesh Export";

                    }
                    else if (nodeName == previousName)
                    {

                        GameObject PrevexistingObject = GameObject.Find(previousName);
                        PrevexistingObject.name = nodeName;
                        previousName = nodeName;
                        name = nodeName;
                    }
                    else
                    {
                        name = nodeName;
                    }



                    NodePort p = b.Ports.First();
                    var meshes = (List<Mesh>)graph.current.GetValue(p);


                    GameObject existingObject = GameObject.Find(name);

                    MeshExport test = graph.current.ConvertTo<MeshExport>();


                    if (existingObject == null)
                    {
                        Debug.Log("it was null");
                        GameObject newObject = new GameObject(name);
                        newObject.transform.SetParent(gameObject.transform, false);
                        if (meshes != null)
                        {

                            for (int i = 0; i < meshes.Count; i++)
                            {
                                GameObject newChildObject = new GameObject("mesh");
                                newChildObject.transform.parent = newObject.transform;

                                MeshFilter meshFilterChildren = newChildObject.AddComponent<MeshFilter>();
                                meshFilterChildren.mesh = meshes[i];
                                MeshRenderer meshRendererChildren = newChildObject.AddComponent<MeshRenderer>();

                            }
                        }

                    }
                    else
                    {
                        Transform[] children = existingObject.GetComponentsInChildren<Transform>();
                        // If the game object already exists, update the mesh
                        if (meshes != null)
                        {
                            if (meshes.Count >= 0)
                            {


                                if (meshes.Count == children.Length - 1)
                                {

                                    for (int i = 0; i < meshes.Count; i++)
                                    {
                                        MeshFilter meshFilter = children[i + 1].gameObject.GetComponent<MeshFilter>();
                                        //if (meshFilter != null)
                                        //{
                                        meshFilter.mesh = meshes[i]; // Assign the specified mesh to the MeshFilter
                                                                     // }
                                    }
                                }
                                else
                                {
                                    if (meshes.Count > children.Length - 1)
                                    {
                                        GameObject newChildObject = new GameObject("mesh");

                                        newChildObject.transform.parent = existingObject.transform;

                                        MeshFilter meshFilterChildren = newChildObject.AddComponent<MeshFilter>();
                                        meshFilterChildren.mesh = meshes[children.Length - 1];
                                        MeshRenderer meshRendererChildren = newChildObject.AddComponent<MeshRenderer>();
                                    }
                                    else
                                    {
                                        DestroyImmediate(children[children.Length - 1].gameObject);
                                    }


                                }

                            }
                        }



                    }





                }
                //________________________________________________________________________________________________________________________________________
                //________________________________________________________________________________________________________
                else if (graph.current.GetString() == "ExportMesh")
                {

                    NodePort p = b.Ports.First();
                    var meshes = (List<Mesh>)graph.current.GetValue(p);
                    string nodeName = graph.current.name;
                    MeshExport s = (MeshExport)graph.current;
                    int id = s.id;
                    string name = id.ToString();

                    string idString = id.ToString();
                   // idString = idString.Substring(1, 3);


                    name = idString + s.name + privateId;
                    name = s.name + "_" + privateId + "_" + idString;

                    if (string.IsNullOrEmpty(name))
                    {
                        return;
                    }

                    MeshExport nodeCurve = s;

                    List<XNode.Node> connectedNodes = new List<XNode.Node>();
                    foreach (var inputPort in nodeCurve.Inputs)
                    {
                        if (inputPort.fieldName == "Sliders")
                        {
                            // Iterate through the connected output ports
                            foreach (var connection in inputPort.GetConnections())
                            {
                                // Retrieve the connected node
                                var connectedNode = connection.node;
                                connectedNodes.Add(connectedNode);
                            }
                        }
                    }
                    Color c = nodeCurve.colour;


                    GameObject existingObject = GameObject.Find(name);

                    if (existingObject == null)
                    {


                        GameObject newObject = new GameObject(name);
                        newObject.transform.SetParent(this.transform, false);
                        ExportCurveComp exportCurveSlider;
                        // ExportCurveComp exportCurveSlider = newObject.AddComponent<ExportCurveComp>();
                        if (!newObject.TryGetComponent<ExportCurveComp>(out exportCurveSlider))
                        {
                            exportCurveSlider = newObject.AddComponent<ExportCurveComp>();
                        }
                        //newObject.transform.SetParent(gameObject.transform, false); //do smth

                        exportCurveSlider.sliders = connectedNodes;



                        for (int i = 0; i < meshes.Count; i++)
                        {
                            GameObject newChildObject = new GameObject("Mesh");

                            newChildObject.transform.SetParent(newObject.transform, false);
                            newChildObject.transform.parent = newObject.transform;
                            //newChildObject.transform.parent = newObject.transform;
                            //newChildObject.transform.SetParent( newObject.transform, false);

                            MeshFilter meshFilterChildren = newChildObject.AddComponent<MeshFilter>();
                            Mesh transformedMesh = Instantiate(meshes[i]);
                            Vector3[] vertices = transformedMesh.vertices;

                            if (positionBinde)
                            {

                                for (int n = 0; n < vertices.Length; n++)
                                {
                                    vertices[n] = TransformPointWithRotationAndScale(vertices[n], newChildObject.transform);

                                }
                            }
                            transformedMesh.SetVertices(vertices);
                            meshFilterChildren.mesh = transformedMesh;
                            MeshRenderer meshRenderer = newChildObject.AddComponent<MeshRenderer>();

                            meshRenderer.sharedMaterial = new Material(Shader.Find("Standard"));
                            meshRenderer.sharedMaterial.color = c;
                        }



                    }

                    else
                    {
                        ExportCurveComp exportCurveSlider;
                        if (existingObject.TryGetComponent<ExportCurveComp>(out exportCurveSlider))
                        {
                            exportCurveSlider.sliders = connectedNodes;
                        }
                        else
                        {
                            exportCurveSlider = existingObject.AddComponent<ExportCurveComp>();
                            exportCurveSlider.sliders = connectedNodes;
                        }
                        //ExportCurveComp exportCurveSlider = existingObject.GetComponent<ExportCurveComp>();
                        //exportCurveSlider.sliders = connectedNodes;
                        Transform[] children = existingObject.GetComponentsInChildren<Transform>();
                        exportCurveSlider.sliders = connectedNodes;



                        if (meshes != null)
                        {

                            if (meshes.Count > 0)
                            {


                                if (meshes.Count == children.Length - 1)
                                {

                                    for (int i = 0; i < meshes.Count; i++)
                                    {
                                        MeshFilter meshFilter = children[i + 1].gameObject.GetComponent<MeshFilter>();
                                        MeshRenderer meshRenderer = children[i + 1].gameObject.GetComponent<MeshRenderer>();
                                        Mesh transformedMesh = Instantiate(meshes[i]);
                                        Vector3[] vertices = transformedMesh.vertices;

           

                                        transformedMesh.SetVertices(vertices);
                                        meshFilter.mesh = transformedMesh;

                                        meshRenderer.sharedMaterial = new Material(Shader.Find("Standard"));
                                        meshRenderer.sharedMaterial.color = c;

                                    }
                                }
                                else
                                {
                                    if (meshes.Count > children.Length - 1)
                                    {

                                        //GameObject newChildObject = new GameObject("Curve");
                                        //newChildObject.transform.parent = existingObject.transform;

                                        //MeshFilter meshFilter = newChildObject.AddComponent<MeshFilter>();
                                        //MeshRenderer meshRenderer = newChildObject.AddComponent<MeshRenderer>();
                                        //Mesh transformedMesh = Instantiate(meshes[meshes.Count - 1]);
                                        //Vector3[] vertices = transformedMesh.vertices;


                                        //transformedMesh.SetVertices(vertices);
                                        //meshFilter.mesh = transformedMesh;
                                        //meshRenderer.sharedMaterial = new Material(Shader.Find("Standard"));
                                        //meshRenderer.sharedMaterial.color = c;
                                        newExportMesh(ref existingObject, ref meshes, ref children, name, c);

                                    }
                                    else
                                    {
                                        removeMeshExport(ref children, ref meshes);

                                    }


                                }

                            }
                        }



                    }
                }

                //________________________________________________________________________________CURVE EXPORT
                else if (graph.current.GetString() == "ExportCurve")
                {

                    NodePort p = b.Ports.First();
                    var curves = (List<Curve>)graph.current.GetValue(p);
                    string nodeName = graph.current.name;
                    CurveExport s = (CurveExport)graph.current;
                    int id = s.id;
                    string name = id.ToString();

                    string idString = id.ToString();
                   // idString = idString;//.Substring(1, 3);
                    var baseName = idString + " Curve Export";


                    //if (nodeName == "Curve Export")
                    //{
                    //    name = baseName;
                    //}

                    //else
                    //{
                    //    name = nodeName;
                    //}
                    name = idString + s.name + privateId;
                    name = s.name + "_" + privateId + "_" + idString;
                    //if (child)
                    //{
                    //    name = name + privateId;
                    //}
                    CurveExport nodeCurve = s;
                    if (string.IsNullOrEmpty(name))
                    {
                        return;
                    }

                    List<XNode.Node> connectedNodes = new List<XNode.Node>();
                    foreach (var inputPort in nodeCurve.Inputs)
                    {
                        if (inputPort.fieldName == "Sliders")
                        {
                            // Iterate through the connected output ports
                            foreach (var connection in inputPort.GetConnections())
                            {
                                // Retrieve the connected node
                                var connectedNode = connection.node;
                                connectedNodes.Add(connectedNode);
                            }
                        }
                    }
                    Color c = nodeCurve.colour;
                    float thickness;
                    try
                    {
                        thickness = nodeCurve.thickness[0];
                    }
                    catch { thickness = 5f; }

                    var existingObject = GameObject.Find(name);



                    if (existingObject == null)
                    {

                        GameObject newObject = new GameObject(name);
                        newObject.transform.SetParent(this.transform, false);
                        ExportCurveComp exportCurveSlider;
                        newObject.TryGetComponent<ExportCurveComp>(out exportCurveSlider);
                        if (!newObject.TryGetComponent<ExportCurveComp>(out exportCurveSlider))
                        {
                            exportCurveSlider = newObject.AddComponent<ExportCurveComp>();
                        }
                        if(exportCurveSlider == null)
                        {
                            exportCurveSlider = newObject.AddComponent<ExportCurveComp>();
                        }
                        //Debug.Log(connectedNodes);
                        //Debug.Log(exportCurveSlider);
                        //  Debug.Log(!newObject.TryGetComponent<ExportCurveComp>(out exportCurveSlider) + "result");

                        exportCurveSlider.sliders = connectedNodes;
                        exportCurveSlider.compPrivateId = privateId;


                        for (int i = 0; i < curves.Count; i++)
                        {
                            GameObject newChildObject = new GameObject(name);
                            newChildObject.transform.SetParent(newObject.transform, false);
                            newChildObject.transform.parent = newObject.transform;

                            LineRenderer curveFilterChildren = newChildObject.AddComponent<LineRenderer>();


                            Vector3[] curvePoints;

                            if (curves[i].type == 1)
                            {
                                curvePoints = Curves.bezier.generateBezier(curves[i].ControlPoints, 40, false);
                            }
                            else
                            {
                                curvePoints = curves[i].ControlPoints;
                            }
                            var curvePointsUpdated = new Vector3[curvePoints.Length];
                            if (positionBinde)
                            {

                                for (int n = 0; n < curvePoints.Length; n++)
                                {
                                    curvePointsUpdated[n] = TransformPointWithRotationAndScale(curvePoints[n], newChildObject.transform);

                                }
                            }
                            else
                            {
                                curvePointsUpdated = curvePoints;
                            }

                            curveFilterChildren.material = new Material(Shader.Find("Particles/Standard Unlit"));

                            curveFilterChildren.startColor = c;
                            curveFilterChildren.endColor = c;
                            curveFilterChildren.startWidth = thickness;
                            curveFilterChildren.endWidth = thickness;

                            curveFilterChildren.positionCount = (curvePointsUpdated.Length);
                            curveFilterChildren.numCapVertices = 1;
                            curveFilterChildren.SetPositions(curvePointsUpdated);

                            MoveLineRendererWithTransform moveCurve;
                            if (!newChildObject.TryGetComponent<MoveLineRendererWithTransform>(out moveCurve))
                            {
                                moveCurve = newChildObject.AddComponent<MoveLineRendererWithTransform>();
                            }

                        }


                    }

                    else
                    {
                        ExportCurveComp exportCurveSlider;
                        if (existingObject.TryGetComponent<ExportCurveComp>(out exportCurveSlider))
                        {
                            exportCurveSlider.sliders = connectedNodes;
                        }
                        else
                        {
                            exportCurveSlider = existingObject.AddComponent<ExportCurveComp>();
                            exportCurveSlider.sliders = connectedNodes;
                        }
                        // ExportCurveComp exportCurveSlider = existingObject.GetComponent<ExportCurveComp>();

                        Transform[] children = existingObject.GetComponentsInChildren<Transform>();

                        exportCurveSlider.sliders = connectedNodes;


                        if (curves != null)
                        {

                            if (curves.Count > 0)
                            {


                                if (curves.Count == children.Length - 1)
                                {

                                    for (int i = 0; i < curves.Count; i++)
                                    {
                                        LineRenderer linerenderer = children[i + 1].gameObject.GetComponent<LineRenderer>();

                                        Vector3[] curvePoints;
                                        if (curves[i].type == 1)
                                        {
                                            curvePoints = Curves.bezier.generateBezier(curves[i].ControlPoints, 40, false);
                                        }
                                        else
                                        {
                                            curvePoints = curves[i].ControlPoints;
                                        }
                                        MoveLineRendererWithTransform moveCurve;
                                        if (!children[i + 1].TryGetComponent<MoveLineRendererWithTransform>(out moveCurve))
                                        {
                                            moveCurve = children[i + 1].AddComponent<MoveLineRendererWithTransform>();
                                        }
                                        var curvePointsUpdated = new Vector3[curvePoints.Length];

                                        if (positionBinde)
                                        {

                                            for (int n = 0; n < curvePoints.Length; n++)
                                            {
                                                curvePointsUpdated[n] = TransformPointWithRotationAndScale(curvePoints[n], children[i + 1].transform);

                                            }
                                        }
                                        else
                                        {
                                            curvePointsUpdated = curvePoints;
                                        }
                                        moveCurve.initialPositions = curvePoints;


                                        linerenderer.material = new Material(Shader.Find("Particles/Standard Unlit"));
                                        linerenderer.startColor = c;
                                        linerenderer.endColor = c;
                                        linerenderer.startWidth = thickness;
                                        linerenderer.endWidth = thickness;
                                        linerenderer.numCapVertices = 1;
                                        linerenderer.positionCount = (curvePointsUpdated.Length);
                                        linerenderer.SetPositions(curvePointsUpdated);

                                    }
                                }
                                else
                                {
                                    if (curves.Count > children.Length - 1)
                                    {
                                        newExportCurve(ref existingObject, c, ref curves, ref children, thickness, name);

                                    }
                                    else
                                    {
                                        removeExportCurve(ref children, ref curves, ref existingObject);
                                        //MoveLineRendererWithTransform test;
                                        //if (children[children.Length - 1].TryGetComponent<MoveLineRendererWithTransform>(out test))
                                        //{
                                        //    DestroyImmediate(test);
                                        //}
                                        //DestroyImmediate(children[children.Length - 1].gameObject);
                                    }

                                }

                            }
                        }



                    }
                }

                //___________________________________________________________________________________


            }


        }
        public void removeMeshExport(ref Transform[] children, ref List<Mesh> meshes)
        {
            DestroyImmediate(children[children.Length - 1].gameObject);
            if (meshes.Count < children.Length - 1)
            {
                removeMeshExport(ref children, ref meshes);
            }
        }
        public void newExportMesh(ref GameObject existingObject, ref List<Mesh> meshes, ref Transform[] children, string realname, Color c)
        {



            GameObject newChildObject = new GameObject(realname);
            newChildObject.transform.parent = existingObject.transform;

            MeshFilter meshFilter = newChildObject.AddComponent<MeshFilter>();
            MeshRenderer meshRenderer = newChildObject.AddComponent<MeshRenderer>();
            Mesh transformedMesh = Instantiate(meshes[meshes.Count - 1]);
            Vector3[] vertices = transformedMesh.vertices;


            transformedMesh.SetVertices(vertices);
            meshFilter.mesh = transformedMesh;
            meshRenderer.sharedMaterial = new Material(Shader.Find("Standard"));
            meshRenderer.sharedMaterial.color = c;

            if (meshes.Count > children.Length - 1)
            {
                newExportMesh(ref existingObject, ref meshes, ref children, realname, c);
            }
        }
        #endregion
        public void newExportCurve(ref GameObject existingObject, Color c, ref List<Curve> curves, ref Transform[] children, float thickness, string Realname)
        {
            GameObject newChildObject = new GameObject(Realname);
            if (existingObject == null) { return; }
            newChildObject.transform.SetParent(existingObject.transform, false);
            newChildObject.transform.parent = existingObject.transform;


            LineRenderer curveFilterChildren = newChildObject.AddComponent<LineRenderer>();
            Vector3[] curvePoints;
            if (curves[children.Length - 1].type == 1)
            {
                curvePoints = Curves.bezier.generateBezier(curves[children.Length - 1].ControlPoints, 40, false);
            }
            else
            {
                curvePoints = curves[children.Length - 1].ControlPoints;
            }

            var curvePointsUpdated = new Vector3[curvePoints.Length];
            if (positionBinde)
            {

                for (int n = 0; n < curvePoints.Length; n++)
                {
                    curvePointsUpdated[n] = TransformPointWithRotationAndScale(curvePoints[n], children[children.Length - 1].transform);

                }
            }
            else
            {
                curvePointsUpdated = curvePoints;
            }
            curveFilterChildren.material = new Material(Shader.Find("Particles/Standard Unlit"));
            curveFilterChildren.startColor = c;
            curveFilterChildren.endColor = c;
            curveFilterChildren.startWidth = thickness;
            curveFilterChildren.endWidth = thickness;
            curveFilterChildren.positionCount = (curvePointsUpdated.Length);
            curveFilterChildren.numCapVertices = 1;
            curveFilterChildren.SetPositions(curvePointsUpdated);

            children = existingObject.GetComponentsInChildren<Transform>();
            if (curves.Count > children.Length - 1)
            {
                newExportCurve(ref existingObject, c, ref curves, ref children, thickness, Realname);
            }

        }
        public void removeExportCurve(ref Transform[] children, ref List<Curve> curves, ref GameObject existingObject)
        {
            MoveLineRendererWithTransform test;
            if (children[children.Length - 1].TryGetComponent<MoveLineRendererWithTransform>(out test))
            {
                DestroyImmediate(test);
            }
            DestroyImmediate(children[children.Length - 1].gameObject);
            children = existingObject.GetComponentsInChildren<Transform>();
            if (curves.Count < children.Length - 1)
            {
                removeExportCurve(ref children, ref curves, ref existingObject);
            }
        }
        //bool finishMirroring = false;
        int plugpeaCounts;
        public void Update()
        {


            if (graph == null)
            {
                return;

            }
            //if (graph.plugpeaID != Id || !graph.childIDs.Contains(Id))
            //{
            //    graph.childIDs.Add(Id);
            //}


            //lock (GUIDManager.plugpeaDictionary)
            //{
            //    if (!GUIDManager.plugpeaDictionary.ContainsKey(objectGUID))
            //    {
            //        GUIDManager.plugpeaDictionary.Add(objectGUID, this);
            //    }
            //}
            //lock (GUIDManager.plugpeaDictionaryID)
            //{
            //    lock (GUIDManager.plugpeaDictionaryID)
            //    {
            //        if (!GUIDManager.plugpeaDictionaryID.ContainsKey(Id))
            //        {
            //            GUIDManager.plugpeaDictionaryID.Add(Id, this);
            //        }
            //        else
            //        {
            //            GUIDManager.plugpeaDictionaryID[Id] = (PlugPea)this;

            //        }
            //    }
            //}
            //PlugPea[] components = FindObjectsOfType<PlugPea>();
            //if (components.Length != plugpeaCounts)
            //{
            //    updateAll();
            //    plugpeaCounts = components.Length;
            //}


            if (GUIDManager.plugpeaDictionaryID.Count != plugpeaCounts)
            {
                updateAll();

                plugpeaCounts = GUIDManager.plugpeaDictionaryID.Count;
            }


            //  if (graph.currentGameobject.ToSafeString() != this.gameObject.ToSafeString()) { return; }
            if (gameObject.name == "GameObject")
            {
                int uniqueID = 0;

                uniqueID = GenerateUniqueID();

                gameObject.name = "GameObject" + uniqueID.ToString();
                //graph.name = gameObject.name;

                graph.GraphName = gameObject.name;
            }
            else
            {
                //graph.name = gameObject.name;
                graph.GraphName = gameObject.name;
            }
            if (Selection.activeGameObject == this.gameObject)
            {

                var wind = NodeEditorWindow.current;
                if (NodeEditorWindow.current != null)
                {
                    if (NodeEditorWindow.current.graph != graph)
                    {
                        wind.LoadGraph(graph);
                        wind.titleContent = new GUIContent(text: graph.name);
                    }
                }

            }
            foreach (Node b in graph.nodes)
            {
                if (b is InputNode inputnode)
                {

                    if (!inputNodes.Exists(node => node == inputnode))
                    {
                        if (inputnode is Slider slider)
                        {

                            slider.OnInputValueChanged += HandleInputValueChanged;
                            inputNodes.Add(slider);
                        }

                    }


                    inputnode.Update();
                }

            }

            lock (GUIDManager.plugpeaDictionaryID)
            {

                if (!GUIDManager.plugpeaDictionaryID.ContainsKey(Id))
                {
                    GUIDManager.plugpeaDictionaryID.Add(Id, this);

                }
            }

        }
        //            if (Selection.activeGameObject == this.gameObject)
        //        {

        //            var wind = NodeEditorWindow.current;
        //            if (NodeEditorWindow.current != null)
        //            {
        //                if (NodeEditorWindow.current.graph != graph)
        //                {
        //                    wind.LoadGraph(graph);
        //                    wind.titleContent = new GUIContent(text: graph.name);
        //}
        //            }

        //        }

        public void canvasFocus()
        {
            var wind = NodeEditorWindow.current;
            var allpos = new UnityEngine.Vector2(0, 0);
            foreach (Node n in graph.nodes)
            {
                allpos += n.position;
            }
            allpos /= graph.nodes.Count;

            NodeEditorWindow.current.panOffset = -allpos;


        }
        private void OnDestroy()
        {

            //lock (GUIDManager.privateAndNames)
            //{
            //    if (GUIDManager.privateAndNames.ContainsKey(privateId))
            //    {
            //        GUIDManager.privateAndNames.Remove(privateId);
            //    }
            //}
            lock (GUIDManager.plugpeaDictionaryID)
            {
                if (GUIDManager.plugpeaDictionaryID.ContainsKey(Id))
                {
                    GUIDManager.plugpeaDictionaryID.Remove(Id);

                }
            }
            try
            {
                graph.childIDs.RemoveAt(graph.childIDs.IndexOf(privateId));
            }
            catch { }
            try
            {
                graph.childNames.RemoveAt(graph.childIDs.IndexOf(gameObject.name));
            }
            catch { }

            if (graph != null)
            {
                foreach (Node b in graph.nodes)
                {
                    if (b is InputNode inputnode)
                    {
                        //NewSlider bb = (NewSlider)b;

                        if (inputnode is Slider slider)
                        {

                            slider.OnInputValueChanged -= HandleInputValueChanged;
                        }
                    }

                }


            }
            curveDictPreview.Clear();
            pointDictPreview.Clear();
            planeDictPreview.Clear();
            meshDictPreview.Clear();

        }

        // This method will be called when the event is fired.
        private void HandleInputValueChanged(Node n)
        {

            PropagateUpdate(n);

        }

        public void PropagateUpdate(Node startNode)
        {
            // Handle the update logic for this node here...
            //  Debug.Log("Updating node: " + startNode.name + " with new value: ");aefwdwd

            // Then, for each of its output ports...
            foreach (NodePort outputPort in startNode.Outputs)
            {
                // Get the nodes connected to this port
                var connectedNodes = outputPort.GetConnections().Select(p => p.node);

                // For each connected node...
                foreach (Node connectedNode in connectedNodes)
                {
                    // Recursively propagate the update
                    if (connectedNode is BaseNode bb)
                    {
                        UpdateLogicOld(bb, graph);//refresh thisef
                    }
                    PropagateUpdate(connectedNode);
                }
            }
        }











        private void OnDrawGizmos()
        {
            foreach (var kvp in planeDictPreview)
            {


                //if  ((planeDictPreviewBool.ContainsKey(kvp.Key) && planeDictPreviewBool[kvp.Key]) | planeDictPreviewBool.ContainsKey(kvp.Key) == false)wd
                if (graph.previewIds.Contains(kvp.Key))
                {

                    for (int i = 0; i < kvp.Value.Count; i++)
                    {
                        Vector3 Center = kvp.Value[i].basePoint;
                        Vector3 x = kvp.Value[i].X * PlaneSize;
                        Vector3 y = kvp.Value[i].Y * PlaneSize;
                        if (positionBinde)
                        {

                            Quaternion rotation = transform.rotation;
                            Center = Vector3.Scale(Center, transform.localScale);
                            Center = rotation * Center;

                            Center += transform.position;
                            x = rotation * x;
                            y = rotation * y;


                        }

                        Vector3 topright = Center + x + y;
                        Vector3 topleft = Center - x + y;
                        Vector3 bottomleft = Center - x - y;
                        Vector3 bottomright = Center + x - y;


                        //Vector3 pointB = kvp.Value[(i + 1) % kvp.Value.Length];
                        Gizmos.color = Color.blue;
                        Gizmos.DrawLine(Center, Center + y);
                        Gizmos.color = Color.red;
                        Gizmos.DrawLine(Center, Center + x);

                        Gizmos.color = Color.white;
                        Gizmos.DrawLine(topright, topleft);
                        Gizmos.DrawLine(topleft, bottomleft);
                        Gizmos.DrawLine(bottomleft, bottomright);
                        Gizmos.DrawLine(bottomright, topright);
                    }
                }

            }
            //efee


            foreach (var kvp in meshDictPreview)
            {

                //if ((meshDictPreviewBool.ContainsKey(kvp.Key) && meshDictPreviewBool[kvp.Key]) | meshDictPreviewBool.ContainsKey(kvp.Key) == false)
                if (graph.previewIds.Contains(kvp.Key))
                {
                    for (int i = 0; i < kvp.Value.Count; i++)
                    {
                        Mesh mesh = Instantiate(kvp.Value[i]);

                        if (positionBinde)
                        {

                            Vector3[] vertices = mesh.vertices;
                            for (int nn = 0; nn < vertices.Length; nn++)
                            {
                                vertices[nn] = TransformPointWithRotationAndScale(vertices[nn]);
                            }
                            mesh.SetVertices(vertices);


                        }

                        if (mesh != null)
                        {
                            Gizmos.DrawMesh(mesh);
                        }
                    }
                }
                else
                {
                    //Debug.Log("liu");


                }
            }
            Gizmos.color = Color.white;

            foreach (var kvp in curveDictPreview)
            {
                //if ((curveDictPreviewBool.ContainsKey(kvp.Key) && curveDictPreviewBool[kvp.Key]) | curveDictPreviewBool.ContainsKey(kvp.Key) == false)
                if (graph.previewIds.Contains(kvp.Key))
                {
                    for (int i = 0; i < kvp.Value.Count; i++)
                    {
                        Vector3[] curvePoints;
                        if (kvp.Value[i].type == 1)
                        {
                            curvePoints = Curves.bezier.generateBezier(kvp.Value[i].ControlPoints, 40, false);
                        }
                        else
                        {
                            curvePoints = kvp.Value[i].ControlPoints;
                        }
                        var curvePointsUpdated = new Vector3[curvePoints.Length];
                        if (positionBinde)
                        {

                            for (int n = 0; n < curvePoints.Length; n++)
                            {
                                curvePointsUpdated[n] = TransformPointWithRotationAndScale(curvePoints[n]);

                            }
                        }
                        else
                        {
                            curvePointsUpdated = curvePoints;
                        }
                        for (int j = 0; j < curvePoints.Length - 1; j++)
                        {

                            Gizmos.DrawLine(curvePointsUpdated[j], curvePointsUpdated[j + 1]);

                        }


                    }
                }

            }
            //efeeewefw
            foreach (var kvp in pointDictPreview)
            {

                //if ((pointDictPreviewBool.ContainsKey(kvp.Key) && pointDictPreviewBool[kvp.Key]) | pointDictPreviewBool.ContainsKey(kvp.Key) == false)
                if (graph.previewIds.Contains(kvp.Key))
                {
                    for (int i = 0; i < kvp.Value.Count; i++)
                    {

                        Vector3 ptToDisplay = kvp.Value[i];
                        if (positionBinde)
                        {
                            Quaternion rotation = transform.rotation;
                            ptToDisplay = Vector3.Scale(ptToDisplay, transform.localScale);
                            ptToDisplay = rotation * ptToDisplay;

                            ptToDisplay += transform.position;
                        }

                        Gizmos.DrawWireSphere(ptToDisplay, pointSize);

                    }
                }
            }


        }

        private Vector3 TransformPointWithRotationAndScale(Vector3 point)
        {
            // Apply the scaling transformation
            Vector3 scaledPoint = Vector3.Scale(point, transform.localScale);

            Quaternion rotation = transform.rotation;

            Vector3 rotatedPts = rotation * scaledPoint;

            Vector3 transformedPoint = rotatedPts + transform.position;
            return transformedPoint;
        }
        private Vector3 TransformPointWithRotationAndScale(Vector3 point, Transform t)
        {
            // Apply the scaling transformation
            Vector3 scaledPoint = Vector3.Scale(point, t.localScale);

            Quaternion rotation = t.rotation;

            Vector3 rotatedPts = rotation * scaledPoint;

            Vector3 transformedPoint = rotatedPts + t.position;
            return transformedPoint;
        }



    }

    [CustomEditor(typeof(PlugPea)), CanEditMultipleObjects]
    public class NodeParserEditor1 : Editor
    {
        private bool debugMode = false;  //turn off before release
        bool showFoldout = false;
        string enableEditingName = "Show Sliders";
        public override void OnInspectorGUI()
        {

            Color defaultColorfont = GUI.color;
            Color defaultColor = GUI.backgroundColor;
            PlugPea nodeParser = (PlugPea)target;

            if (debugMode)
            {

                GUILayout.BeginHorizontal();
                GUILayout.Label("Id");
                EditorGUILayout.TextField(nodeParser.Id);
                GUILayout.EndHorizontal();

                GUILayout.BeginHorizontal();
                GUILayout.Label("Private Id");
                EditorGUILayout.TextField(nodeParser.privateId);
                GUILayout.EndHorizontal();

                GUILayout.BeginHorizontal();
                GUILayout.Label("Graph Id");
                EditorGUILayout.TextField(nodeParser.graph.plugpeaID);
                GUILayout.EndHorizontal();

                GUILayout.BeginHorizontal();
                GUILayout.Label("child");
                EditorGUILayout.TextField(nodeParser.child.ToSafeString());
                GUILayout.EndHorizontal();

                GUI.backgroundColor = Color.red; GUILayout.Box("", new GUILayoutOption[] { GUILayout.ExpandWidth(true), GUILayout.Height(4) }); GUI.backgroundColor = defaultColor;
            }



            if (nodeParser.child)
            {
                if (GUILayout.Button("Detached Graph"))
                {
                    nodeParser.detached();
                }
            }

            //EditorGUILayout.PropertyField(serializedObject.FindProperty("graph"), true);


            if (GUILayout.Button("Update Nodes"))
            {
                nodeParser.updateAll();
            }




            if (GUILayout.Button(enableEditingName))
            {
                if (nodeParser.enableEditing)
                {
                    nodeParser.enableEditing = false;
                    enableEditingName = "Hide Sliders";
                }
                else
                {
                    nodeParser.enableEditing = true;
                    enableEditingName = "Show Sliders";
                }
            }
            if (GUILayout.Button("Focus"))
            {
                nodeParser.canvasFocus();
            }
            //bool EnableEditingToggle = nodeParser.enableEditing;
            //EnableEditingToggle = GUILayout.Toggle(EnableEditingToggle, "Show Sliders");

            bool positionBindeToggle = nodeParser.positionBinde;



            //foldout styel 

            GUIStyle foldoutStyle = new GUIStyle(EditorStyles.foldout);
            foldoutStyle.fontStyle = FontStyle.Bold;
            foldoutStyle.normal.textColor = new Color(244, 237, 186);
            //  foldoutStyle.onNormal.textColor = Color.red;



            GUI.backgroundColor = Color.black; GUILayout.Box("", new GUILayoutOption[] { GUILayout.ExpandWidth(true), GUILayout.Height(4) }); GUI.backgroundColor = defaultColor;

            // Reset background color

            //---------
            showFoldout = EditorGUILayout.Foldout(showFoldout, "Setting", foldoutStyle);
            // serializedObject.Update();
            if (showFoldout)
            {
                positionBindeToggle = GUILayout.Toggle(positionBindeToggle, "Localize Position");

                nodeParser.PlaneSize =  EditorGUILayout.Slider("Plane Size", nodeParser.PlaneSize, 0, 20);
                nodeParser.pointSize = EditorGUILayout.Slider("Point Size", nodeParser.pointSize, 0, 20);
    
                GUI.color = Color.white;


            }

            nodeParser.positionBinde = positionBindeToggle;

            base.DrawDefaultInspector();

            GUILayout.Space(6);




            if (nodeParser.enableEditing)
            {
                GUI.backgroundColor = Color.black;

                GUILayout.Box("", new GUILayoutOption[] { GUILayout.ExpandWidth(true), GUILayout.Height(4) }); GUI.backgroundColor = defaultColor;
                GUILayout.Label("Sliders", EditorStyles.boldLabel);
                GUILayout.Space(6);
                if (nodeParser.graph.nodes != null)
                {

                    foreach (Node c in nodeParser.graph.nodes)
                    {

                        if (c is InputNode b)
                        {

                            if (b.GetString() == "Slider")
                            {

                                Slider test = (Slider)b.ConvertTo<Slider>();
                                GameObject so = test.currentGameobject;
                                if (true)
                                {
                                    // GUILayout.Label(test.name, EditorStyles.boldLabel);
                                    float initValue = test.sliderValue;
                                    //add foldout

                                    GUILayout.BeginHorizontal();
                                    test.foldoutInspector = EditorGUILayout.BeginFoldoutHeaderGroup(test.foldoutInspector, "");
                                    GUILayout.Space(-100);
                                    float userValue = EditorGUILayout.Slider(test.name, initValue, test.minValue, test.maxValue);
                                    GUILayout.EndHorizontal();

                                    if (test.foldoutInspector)
                                    {
                                        GUILayout.Space(10);
                                        EditorGUI.indentLevel++;
                                        test.minValue = EditorGUILayout.FloatField("Min Value", test.minValue);
                                        GUILayout.Space(2);
                                        test.maxValue = EditorGUILayout.FloatField("Max Value", test.maxValue);
                                        EditorGUI.indentLevel--;
                                        GUILayout.Space(10);
                                    }

                                    EditorGUILayout.EndFoldoutHeaderGroup();



                                    // userValue = EditorGUILayout.FloatField("Value", userValue);
                                    userValue = Mathf.Clamp(userValue, test.minValue, test.maxValue);

                                    if (initValue != userValue)
                                    {
                                        test.Update();
                                    }

                                    test.SetValue(userValue);
                                }
                            }
                        }

                    }



                }
            }

        }
    }
}

