using Unity.VisualScripting;
using XNodeEditor;
using plugpea;
using UnityEngine;
using UnityEditor;
using System.Linq;
using System;
using XNode;
using System.Collections.Generic;
using PlugPeaNodes;
namespace plugpea
{
    [CustomNodeGraphEditor(typeof(PlugPeaGraph))]


    public class PlugPea_NodeEditor : NodeGraphEditor
    {
        public static bool isPopupOpen = false;
        Vector2 lastMousePosition;
        public override void OnGUI()
        {

            //base.OnGUI();
            if (Event.current.type == EventType.KeyDown && (Event.current.keyCode == KeyCode.Return || Event.current.keyCode == KeyCode.Space || Event.current.keyCode == KeyCode.KeypadEnter))
            {
                isPopupOpen = true;
                lastMousePosition = Event.current.mousePosition;
                InputPopup.Init(OnSubmit);
                Event.current.Use();
            }
        }

        void OnSubmit(float value)
        {






            isPopupOpen = false;
            Vector2 position = NodeEditorWindow.current.WindowToGridPosition(lastMousePosition);

            PlugPeaGraph graph = target as PlugPeaGraph;
            PlugPeaNodes.Slider sliderNode = target.AddNode<PlugPeaNodes.Slider>(position);
            sliderNode.graph = target;
            sliderNode.name = "Slider";
            sliderNode.sliderValue = value;
            if (value < 10 && 0 < value)
            {

                sliderNode.minValue = 0f;
                sliderNode.maxValue = 10;

            }

            else if (value < 100 && 0 < value)
            {

                sliderNode.minValue = 0f;
                sliderNode.maxValue = 100;

            }

            else if (value < 1 && -1 < value)
            {

                sliderNode.minValue = -1f;
                sliderNode.maxValue = 1f;

            }

            else
            {
                if (value > 0)
                {
                    sliderNode.minValue = 0f;
                    sliderNode.maxValue = value;
                }
                else
                {
                    sliderNode.minValue = value;
                    sliderNode.maxValue = 0f;
                }

            }
            var newList = new List<Node>(target.nodes);
            target.nodes = newList;



            sliderNode.position = position + new Vector2(-100, -25);
            string _path = AssetDatabase.GetAssetPath(target.GetInstanceID());
            AssetDatabase.AddObjectToAsset(target.nodes[target.nodes.Count - 1], _path);
        }
        public override float GetNoodleThickness(bool selected, NodePort output, NodePort input)
        {
            if (selected)
            {
                return base.GetNoodleThickness(selected, output, input);
            }
            return 7;

        }


        public override string GetNodeMenuName(System.Type type)
        {

            if (type.Namespace == "plugpea")
            {
                return base.GetNodeMenuName(type) + " (Plug Pea)";
            }
            return base.GetNodeMenuName(type);
        }


    }
}