using UnityEditor;
using UnityEngine;

using static UnityEngine.GraphicsBuffer;
using XNodeEditor;


namespace plugpea
{
    [ExecuteInEditMode]

    public class InputPopup : EditorWindow
    {
        public static bool isPopupOpen = false;
        string inputString = "";

        public static void Init(System.Action<float> onSubmit)
        {
            InputPopup window = ScriptableObject.CreateInstance<InputPopup>();
            window.onSubmit = onSubmit;
            Vector2 size = new Vector2(200, 60);
            Vector2 mousePosition = EditorGUIUtility.GUIToScreenPoint(Event.current.mousePosition);
            Vector2 halfSize = size * 0.5f;
            window.position = new Rect(mousePosition - halfSize, size);

            //  window.position = new Rect(mousePosition, size);
            window.ShowPopup();
        }

        private System.Action<float> onSubmit;
        void OnGUI()
        {
            bool submit = false;
            Color originalColor = GUI.backgroundColor;
            GUI.backgroundColor = new Color(0.2f, 0.6f, 0.8f, 1f);
            if (Event.current.type == EventType.KeyDown &&
                (Event.current.keyCode == KeyCode.Return || Event.current.keyCode == KeyCode.Space || Event.current.keyCode == KeyCode.KeypadEnter))
            {
                submit = true;
                Event.current.Use();
            }

            //GUILayout.Label("Enter your number", EditorStyles.boldLabel);
            GUI.SetNextControlName("MyTextField");
            inputString = EditorGUILayout.TextField(inputString);

            if (Event.current.type == EventType.Repaint || submit == false)
            {
                if (!string.IsNullOrEmpty(GUI.GetNameOfFocusedControl()))
                {
                    if (GUI.GetNameOfFocusedControl() != "MyTextField")
                    {
                        GUI.FocusControl("MyTextField");
                    }
                }
                else
                {
                    GUI.FocusControl("MyTextField");
                }
            }

            if (submit || GUILayout.Button("Submit"))
            {
                if (float.TryParse(inputString, out float value))
                {
                    onSubmit?.Invoke(value);
                }

                this.Close();
            }
            GUI.backgroundColor = originalColor;
        }
    }
}
