using plugpea;
using Unity.VisualScripting;
using UnityEditor;
using UnityEngine;
namespace plugpea
{
    public class CustomGameObjectPreset
    {
        [MenuItem("GameObject/PlugPea GameObject", false, 0)]
        private static void GameObjectGraph()
        {
            GameObject emptyObject = new GameObject("CustomEmptyObject");

            // Add your desired component to the empty object
            PlugPea pp = emptyObject.AddComponent<PlugPea>();

            string folderPath = "Assets/PlugPea Graphs";

            string graphName = "NewAutoPlugPeaGraph";
            var graph = createGraph(folderPath, graphName, emptyObject);
            //pp.Awake();
            graph.plugpeaGUID = pp.objectGUID;
            Vector3 center = Vector3.zero;
            if (SceneView.lastActiveSceneView != null)
                center = SceneView.lastActiveSceneView.pivot;

            emptyObject.transform.position = center;

            //Debug.Log("the guid is" + pp.Id);
            //Debug.Log("this graph is" + graph.plugpeaID);
            pp.graph = graph;
            pp.OnEnable();
            pp.updateAll();
            graph.currentGameobject = emptyObject;
            // Optional: You can also parent the new object to the currently selected object in the Hierarchy.
            GameObject selectedObject = Selection.activeGameObject;
            if (selectedObject != null)
                emptyObject.transform.parent = selectedObject.transform;

            Selection.activeGameObject = emptyObject;
        }

        public static PlugPeaGraph createGraph(string folderPath, string graphName, GameObject currentGameobject)
        {
            PlugPeaGraph graphw = ScriptableObject.CreateInstance<PlugPeaGraph>();

            if (!AssetDatabase.IsValidFolder(folderPath))
            {
                AssetDatabase.CreateFolder("Assets", "PlugPea Graphs");
            }

            string graphNameWithNumber = graphName;
            int number = 1;
            while (AssetDatabase.FindAssets(graphNameWithNumber).Length > 0)
            {
                graphNameWithNumber = $"{graphName}{number}";
                number++;
            }
            string path = $"{folderPath}/{graphNameWithNumber}.asset";
            PlugPeaGraph graph = GraphUtils.DuplicateGraph(graphw, path, currentGameobject);

            graph.name = graphNameWithNumber;
            graph.currentGameobject = currentGameobject;
            graph.currentGameobjectString = currentGameobject.name;
            PlugPea pp;
            currentGameobject.TryGetComponent<PlugPea>(out pp);

            graph.plugpeaID = pp.Id;
            graph.plugpeaGUID = pp.objectGUID;





            return graph;
        }
        public static PlugPeaGraph createGraph(string folderPath, string graphName, GameObject currentGameobject, PlugPeaGraph baseGraph)
        {

            if (!AssetDatabase.IsValidFolder(folderPath))
            {
                AssetDatabase.CreateFolder("Assets", "PlugPea Graphs");
            }

            string graphNameWithNumber = graphName;
            int number = 1;
            while (AssetDatabase.FindAssets(graphNameWithNumber).Length > 0)
            {
                graphNameWithNumber = $"{graphName}{number}";
                number++;
            }
            string path = $"{folderPath}/{graphNameWithNumber}.asset";
            PlugPeaGraph graph = GraphUtils.DuplicateGraph(baseGraph, path, currentGameobject);
            graph.name = graphNameWithNumber;
            graph.currentGameobject = currentGameobject;
            string id = currentGameobject.GetInstanceID().ToString();
            graph.GraphName = id;
            graph.id = id;


            return graph;
        }

    }
}