using System.Collections;
using System.Collections.Generic;
using Unity.VisualScripting;
using UnityEditor;
using UnityEngine;
using XNode;
using static UnityEngine.GraphicsBuffer;
using PlugPeaNodes;
using plugpea;
using System;
using UnityEngine.Windows;

namespace plugpea
{
    [ExecuteInEditMode]
    public class ExportCurveComp : MonoBehaviour
    {
        [HideInInspector]
        public List<Node> sliders;
        [HideInInspector]
        public BaseNode HostExportNode;
        [HideInInspector]
        public PlugPea plugpea;
        [HideInInspector]
        public PlugPeaGraph graph;

        Vector3 previousPos;
        Quaternion previousRot;
        Vector3 previousScale;
        LineRenderer lineRenderer;
        [HideInInspector]
        public string compPrivateId;
        private static List<ExportCurveComp> _instances;
        private static ExportCurveComp instance;
      
      
        private void Start()
        {

            Transform parentTransform = transform.parent;
            string currentName = cutted(gameObject.name);
            if (parentTransform != null)
            {
                // Loop through all the children of the parent Transform
                for (int i = 0; i < parentTransform.childCount; i++)
                {
                    Transform childTransform = parentTransform.GetChild(i);

                    // Check if the child GameObject is different from the current GameObject
                    if (childTransform.gameObject != gameObject)
                    {
                        // You can perform any desired operations with immediate siblings here
                       // Debug.Log("Found immediate sibling: " + childTransform.gameObject.name);

                        string node_name =cutted( childTransform.gameObject.name);
                        if(currentName == node_name)
                        {
                            DestroyImmediate(childTransform.gameObject);
                        }
                    

                    }
                }
            }
            if (!string.IsNullOrEmpty(compPrivateId))
            {
                GameObject parent = transform.parent.gameObject;
                PlugPea pp = parent.GetComponent<PlugPea>();
              
                string privateIdPlugpea = pp.privateId;
                Debug.Log(compPrivateId);
                Debug.Log(privateIdPlugpea);
                Debug.Log(parent.name);
                if (pp.privateId != compPrivateId) { DestroyImmediate(gameObject); }
            }
            previousPos = transform.position;
            previousRot = transform.rotation;
            previousScale = transform.localScale;

            lineRenderer = GetComponent<LineRenderer>();
        }
        public string cutted(string input)
        {
            
            int length = input.Length;
            int startIndex = Math.Max(length - 5, 0); // In case the input is shorter than 5 characters

            string lastFiveDigits = input.Substring(startIndex);
            return lastFiveDigits;
        }





    }
    [CustomEditor(typeof(ExportCurveComp))]
    public class ExportCurveCompEditor : Editor
    {
        public override void OnInspectorGUI()
        {
            ExportCurveComp nodeParser = (ExportCurveComp)target;

            base.DrawDefaultInspector();
            GUILayout.Space(6);
            GUILayout.Label("Sliders", EditorStyles.boldLabel);
            GUILayout.Space(6);

            //EditorGUILayout.LabelField("Select an object to prevent duplication.");
            //if (Selection.activeGameObject != null && GUILayout.Button("Prevent Duplication"))
            //{
            //    PreventDuplication(Selection.activeGameObject);
            //}

            foreach (Node c in nodeParser.sliders)
            {
                if (c is InputNode b)
                {

                    if (b.GetString() == "Slider")
                    {

                        Slider test = (Slider)b.ConvertTo<Slider>();

                        // GUILayout.Label(test.name, EditorStyles.boldLabel);
                        float initValue = test.sliderValue;
                        //float userValue = EditorGUILayout.Slider(test.name, initValue, test.minValue, test.maxValue);

                        GUILayout.BeginHorizontal();
                        test.foldoutInspector = EditorGUILayout.BeginFoldoutHeaderGroup(test.foldoutInspector, "");
                        GUILayout.Space(-100);
                        float userValue = EditorGUILayout.Slider(test.name, initValue, test.minValue, test.maxValue);
                        GUILayout.EndHorizontal();

                        if (test.foldoutInspector)
                        {
                            GUILayout.Space(10);
                            EditorGUI.indentLevel++;
                            test.minValue = EditorGUILayout.FloatField("Min Value", test.minValue);
                            GUILayout.Space(2);
                            test.maxValue = EditorGUILayout.FloatField("Max Value", test.maxValue);
                            EditorGUI.indentLevel--;
                            GUILayout.Space(10);
                        }

                        EditorGUILayout.EndFoldoutHeaderGroup();

                        // userValue = EditorGUILayout.FloatField("Value", userValue);
                        userValue = Mathf.Clamp(userValue, test.minValue, test.maxValue);

                        if (initValue != userValue)
                        {
                            test.Update();
                        }

                        test.SetValue(userValue);

                    }
                }

            }

        }

        //void OnGUI()
        //{

        //}

        //private void PreventDuplication(GameObject selectedObject)
        //{
        //    ExportCurveComp[] objects = FindObjectsOfType<ExportCurveComp>();
        //    if (objects.Length > 1)
        //    {
        //        Debug.LogWarning("Duplicate objects are not allowed. Cannot duplicate this object.");
        //        return;
        //    }

        //    // Duplicate the object using Unity's API
        //    GameObject duplicatedObject = Instantiate(selectedObject, selectedObject.transform.parent);

        //    // Set the name of the duplicated object
        //    duplicatedObject.name = selectedObject.name + " (Duplicate)";
        //}
    }




   

}