﻿using PlugPeaNodes;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Unity.VisualScripting;
using UnityEditor;
using UnityEngine;
using XNode;

using Plane = PlugPeaNodes.Plane;

namespace plugpea
{

    [CreateAssetMenu]


    public class PlugPeaGraph : NodeGraph
    {

        public BaseNode current;
        public InputNode present;
        public string id;
        public string GraphName;
        public bool isConnectedToGameobject = false;
        [SerializeField]
        public GameObject currentGameobject;
        public string currentGameobjectString;
        [SerializeField]
        public PlugPea currentComponent;

        public GUID plugpeaGUID;

        private bool deBugMode = false;
        public PlugPea getPlugPea()
        {

            var theGameobject = GameObject.Find(currentGameobjectString);
            try
            {
                PlugPea pp = theGameobject.GetComponent<PlugPea>();
                return pp;
            }
            catch { Debug.Log("Please press the Update all button"); }


            return null;

        }


        public string plugpeaID;
        public List<string> childIDs = new List<string>();

        public Slider getSlider(string SliderName)
        {
            foreach (Node n in nodes)
            {
                if (n is Slider inputnode)
                {
                    if (inputnode.name == SliderName)
                    {
                        return inputnode;
                    }
                }
            }
            return null;
        }

        public PlugPea getPlugPeaViaGUID()
        {
            PlugPea targetComponent = null;
            try
            {
                lock (GUIDManager.plugpeaDictionaryID)
                {
                    if (GUIDManager.plugpeaDictionaryID.ContainsKey(plugpeaID))
                    {
                        targetComponent = GUIDManager.plugpeaDictionaryID[plugpeaID];
                    }
                }
            }
            catch
            {



            }



            return targetComponent;

        }
        [SerializeField]
        public List<int> previewIds = new List<int>();
        public PlugPea PreviewOff(int id)
        {
            PlugPea targetComponent = null;
            try
            {
                lock (GUIDManager.plugpeaDictionaryID)
                {
                    if (GUIDManager.plugpeaDictionaryID.ContainsKey(plugpeaID))
                    {
                        targetComponent = GUIDManager.plugpeaDictionaryID[plugpeaID];
                    }
                }
            }
            catch
            {



            }



            return targetComponent;

        }
        public void UpdateAndPropogate(BaseNode basenode)
        {
            PlugPea[] components = FindObjectsOfType<PlugPea>();
            for (int i = 0; i < components.Length; i++)
            {
                PlugPea targetComponent = components[i];
                if (targetComponent.Id == this.plugpeaID)
                {
                    try
                    {
                        lock (GUIDManager.plugpeaDictionaryID)
                        {
                            targetComponent = GUIDManager.plugpeaDictionaryID[plugpeaID];
                        }

                        if (targetComponent != null)
                        {
                            UpdateLogic(basenode, this);
                            targetComponent.PropagateUpdate(basenode);
                        }
                    }
                    catch
                    {
                        if (deBugMode)
                        {
                            Debug.Log("PlugPea Component is missing!  " + this.name);
                        }

                    }

                }
            }
        }

        public void UpdateNode(BaseNode basenode)
        {
            PlugPea[] components = FindObjectsOfType<PlugPea>();
            for (int i = 0; i < components.Length; i++)
            {
                PlugPea targetComponent = components[i];
                if (targetComponent.Id == this.plugpeaID)
                {

                    try
                    {
                        lock (GUIDManager.plugpeaDictionaryID)
                        {
                            targetComponent = GUIDManager.plugpeaDictionaryID[plugpeaID];
                        }

                        if (targetComponent != null)
                        {
                            targetComponent.UpdateLogicOld((BaseNode)basenode, this);//ef

                        }
                    }
                    catch
                    {
                        if (deBugMode)
                        {
                            Debug.Log("PlugPea Component is missing!  " + this.name);
                        }

                    }
                }
            }


        }


        public void dictPreview(IDictionary<int, bool> dict, int id, ref bool preview, ref string previewName)
        {
            if (preview == false)
            {
                preview = true;
                previewName = "Preview On";

                if (!dict.ContainsKey(id))
                {
                    dict.Add(id, preview);
                }
                else
                {
                    dict[id] = preview;
                }
            }
            else
            {
                preview = false;
                previewName = "Preview Off";
                if (!dict.ContainsKey(id))
                {
                    dict.Add(id, preview);
                }
                else
                {
                    dict[id] = preview;
                }
            }



        }
        List<string> childIds;
        public List<string> childNames = new List<string>();
        public List<PlugPea> getPlugPeas()
        {
            PlugPea[] components = FindObjectsOfType<PlugPea>();
            Debug.Log("base peas: " + components.Length);
            List<PlugPea> relevantPeas = new List<PlugPea>();

            for (int i = 0; i < components.Length; i++)
            {
                //Debug.Log("C : " + components[i].Id + "  graph Id: " + plugpeaID);
                if (components[i].Id == plugpeaID)
                {
                    relevantPeas.Add(components[i]);
                }



            }
            //Debug.Log("relevantPeas:  " + relevantPeas.Count);
            return relevantPeas;


        }

        public IDictionary<int, List<Vector3>> pointDictPreview = new Dictionary<int, List<Vector3>>();
        public IDictionary<int, List<Curve>> curveDictPreview = new Dictionary<int, List<Curve>>();
        public IDictionary<int, List<Plane>> planeDictPreview = new Dictionary<int, List<Plane>>();
        public IDictionary<int, List<Mesh>> meshDictPreview = new Dictionary<int, List<Mesh>>();
        public void UpdateLogic(BaseNode b, PlugPeaGraph graph)
        {

            PlugPeaGraph nodeGraphChecker = b.graph as PlugPeaGraph;

            //if (!(nodeGraphChecker.plugpeaID == this.Id || nodeGraphChecker.childIDs.Contains(Id))) { return; } //detachedGraph==true &&
            int nodeId = b.GetInstanceID();


            graph.current = (BaseNode)b;
            // b.GetString();  
            if (graph.current != null)
            {
                if (graph.current.GetString() == "Draw")
                {

                    object input;
                    var inputType = "null";
                    try
                    {
                        NodePort p = b.Outputs.First();
                        input = graph.current.GetValue(p);
                        inputType = input.GetType().ToString();
                    }
                    catch
                    {
                        NodePort p = b.Ports.First();
                        input = graph.current.GetValue(p);


                    }


                    switch (inputType)
                    {

                        case "System.Collections.Generic.List`1[PlugPeaNodes.Plane]":

                            List<Plane> inputPlane = (List<Plane>)input;
                            List<Plane> tempPlane = new List<Plane>();
                            foreach (var plane in inputPlane)
                            {

                                tempPlane.Add(plane);
                            }
                            if (planeDictPreview.ContainsKey(nodeId))
                            {
                                planeDictPreview[nodeId] = tempPlane;

                            }
                            else
                            {
                                planeDictPreview.Add(nodeId, tempPlane);
                            }

                            break;


                        case "System.Collections.Generic.List`1[PlugPeaNodes.Curve]":
                            List<Curve> inputCurve = (List<Curve>)input;
                            List<Curve> tempCurve = new List<Curve>();
                            foreach (var curve in inputCurve)
                            {

                                tempCurve.Add(curve);
                            }
                            if (curveDictPreview.ContainsKey(nodeId))
                            {
                                curveDictPreview[nodeId] = tempCurve;
                            }
                            else
                            {
                                curveDictPreview.Add(nodeId, tempCurve);
                            }

                            break;

                        case "System.Collections.Generic.List`1[UnityEngine.Mesh]":
                            List<Mesh> inputMesh = (List<Mesh>)input;
                            List<Mesh> tempMesh = new List<Mesh>();
                            foreach (var mesh in inputMesh)
                            {

                                tempMesh.Add(mesh);
                            }
                            if (meshDictPreview.ContainsKey(nodeId))
                            {
                                meshDictPreview[nodeId] = tempMesh;

                            }
                            else
                            {
                                meshDictPreview.Add(nodeId, tempMesh);
                            }

                            break;

                        case "System.Collections.Generic.List`1[Vector3]":
                            List<Vector3> inputPoints = (List<Vector3>)input;
                            List<Vector3> tempPoints = new List<Vector3>();
                            foreach (var point in inputPoints)
                            {

                                tempPoints.Add(point);
                            }
                            if (pointDictPreview.ContainsKey(nodeId))
                            {
                                pointDictPreview[nodeId] = tempPoints;

                            }
                            else
                            {
                                pointDictPreview.Add(nodeId, tempPoints);
                            }

                            break;
                        case "System.Collections.Generic.List`1[UnityEngine.Vector3]":
                            List<Vector3> inputPointss = (List<Vector3>)input;
                            List<Vector3> tempPointss = new List<Vector3>();
                            foreach (var point in inputPointss)
                            {

                                tempPointss.Add(point);
                            }
                            if (pointDictPreview.ContainsKey(nodeId))
                            {
                                pointDictPreview[nodeId] = tempPointss;

                            }
                            else
                            {
                                pointDictPreview.Add(nodeId, tempPointss);
                            }

                            break;
                        case "null":
                            break;


                        //// Add other cases as required...
                        default:
                            //Debug.LogWarning($"Unsupported type {inputType} in ListItemNode.");   //Enable to debug
                            break;
                    }


                }

                else if (graph.current.GetString() == "Slider")
                {
                    NodePort p = b.Outputs.First();
                    graph.current.GetValue(p);
                }

                else if (graph.current.GetString() == "Panel")
                {
                    NodePort p = b.Ports.First();
                    graph.current.GetValue(p);
                }

                ////________________________________________________________________________________________________________
                //else if (graph.current.GetString() == "ExportMesh")
                //{

                //    NodePort p = b.Ports.First();
                //    var meshes = (List<Mesh>)graph.current.GetValue(p);
                //    string nodeName = graph.current.name;
                //    MeshExport s = (MeshExport)graph.current;
                //    int id = s.id;
                //    string name = id.ToString();

                //    string idString = id.ToString();
                //    idString = idString.Substring(1, 3);


                //    name = idString + s.name + privateId;
                //    name = s.name + "_" + privateId + "_" + idString;

                //    if (string.IsNullOrEmpty(name))
                //    {
                //        return;
                //    }

                //    MeshExport nodeCurve = s;

                //    List<XNode.Node> connectedNodes = new List<XNode.Node>();
                //    foreach (var inputPort in nodeCurve.Inputs)
                //    {
                //        if (inputPort.fieldName == "Sliders")
                //        {
                //            // Iterate through the connected output ports
                //            foreach (var connection in inputPort.GetConnections())
                //            {
                //                // Retrieve the connected node
                //                var connectedNode = connection.node;
                //                connectedNodes.Add(connectedNode);
                //            }
                //        }
                //    }
                //    Color c = nodeCurve.colour;


                //    GameObject existingObject = GameObject.Find(name);

                //    if (existingObject == null)
                //    {


                //        GameObject newObject = new GameObject(name);
                //        newObject.transform.SetParent(this.transform, false);
                //        ExportCurveComp exportCurveSlider;
                //        // ExportCurveComp exportCurveSlider = newObject.AddComponent<ExportCurveComp>();
                //        if (!newObject.TryGetComponent<ExportCurveComp>(out exportCurveSlider))
                //        {
                //            exportCurveSlider = newObject.AddComponent<ExportCurveComp>();
                //        }
                //        //newObject.transform.SetParent(gameObject.transform, false); //do smth

                //        exportCurveSlider.sliders = connectedNodes;



                //        for (int i = 0; i < meshes.Count; i++)
                //        {
                //            GameObject newChildObject = new GameObject("Mesh");

                //            newChildObject.transform.SetParent(newObject.transform, false);
                //            newChildObject.transform.parent = newObject.transform;
                //            //newChildObject.transform.parent = newObject.transform;
                //            //newChildObject.transform.SetParent( newObject.transform, false);

                //            MeshFilter meshFilterChildren = newChildObject.AddComponent<MeshFilter>();
                //            Mesh transformedMesh = Instantiate(meshes[i]);
                //            Vector3[] vertices = transformedMesh.vertices;

                //            if (positionBinde)
                //            {

                //                for (int n = 0; n < vertices.Length; n++)
                //                {
                //                    vertices[n] = TransformPointWithRotationAndScale(vertices[n], newChildObject.transform);

                //                }
                //            }
                //            transformedMesh.SetVertices(vertices);
                //            meshFilterChildren.mesh = transformedMesh;
                //            MeshRenderer meshRenderer = newChildObject.AddComponent<MeshRenderer>();

                //            meshRenderer.sharedMaterial = new Material(Shader.Find("Standard"));
                //            meshRenderer.sharedMaterial.color = c;
                //        }



                //    }

                //    else
                //    {
                //        ExportCurveComp exportCurveSlider;
                //        if (existingObject.TryGetComponent<ExportCurveComp>(out exportCurveSlider))
                //        {
                //            exportCurveSlider.sliders = connectedNodes;
                //        }
                //        else
                //        {
                //            exportCurveSlider = existingObject.AddComponent<ExportCurveComp>();
                //            exportCurveSlider.sliders = connectedNodes;
                //        }
                //        //ExportCurveComp exportCurveSlider = existingObject.GetComponent<ExportCurveComp>();
                //        //exportCurveSlider.sliders = connectedNodes;
                //        Transform[] children = existingObject.GetComponentsInChildren<Transform>();
                //        exportCurveSlider.sliders = connectedNodes;



                //        if (meshes != null)
                //        {

                //            if (meshes.Count > 0)
                //            {


                //                if (meshes.Count == children.Length - 1)
                //                {

                //                    for (int i = 0; i < meshes.Count; i++)
                //                    {
                //                        MeshFilter meshFilter = children[i + 1].gameObject.GetComponent<MeshFilter>();
                //                        MeshRenderer meshRenderer = children[i + 1].gameObject.GetComponent<MeshRenderer>();
                //                        Mesh transformedMesh = Instantiate(meshes[i]);
                //                        Vector3[] vertices = transformedMesh.vertices;


                //                        transformedMesh.SetVertices(vertices);
                //                        meshFilter.mesh = transformedMesh;

                //                        meshRenderer.sharedMaterial = new Material(Shader.Find("Standard"));
                //                        meshRenderer.sharedMaterial.color = c;

                //                    }
                //                }
                //                else
                //                {
                //                    if (meshes.Count > children.Length - 1)
                //                    {

                //                        //GameObject newChildObject = new GameObject("Curve");
                //                        //newChildObject.transform.parent = existingObject.transform;

                //                        //MeshFilter meshFilter = newChildObject.AddComponent<MeshFilter>();
                //                        //MeshRenderer meshRenderer = newChildObject.AddComponent<MeshRenderer>();
                //                        //Mesh transformedMesh = Instantiate(meshes[meshes.Count - 1]);
                //                        //Vector3[] vertices = transformedMesh.vertices;


                //                        //transformedMesh.SetVertices(vertices);
                //                        //meshFilter.mesh = transformedMesh;
                //                        //meshRenderer.sharedMaterial = new Material(Shader.Find("Standard"));
                //                        //meshRenderer.sharedMaterial.color = c;
                //                        newExportMesh(ref existingObject, ref meshes, ref children, name, c);

                //                    }
                //                    else
                //                    {
                //                        removeMeshExport(ref children, ref meshes);

                //                    }


                //                }

                //            }
                //        }



                //    }
                //}

                ////________________________________________________________________________________CURVE EXPORT
                //else if (graph.current.GetString() == "ExportCurve")
                //{

                //    NodePort p = b.Ports.First();
                //    var curves = (List<Curve>)graph.current.GetValue(p);
                //    string nodeName = graph.current.name;
                //    CurveExport s = (CurveExport)graph.current;
                //    int id = s.id;
                //    string name = id.ToString();

                //    string idString = id.ToString();
                //    idString = idString.Substring(1, 3);
                //    var baseName = idString + " Curve Export";


                //    //if (nodeName == "Curve Export")
                //    //{
                //    //    name = baseName;
                //    //}

                //    //else
                //    //{
                //    //    name = nodeName;
                //    //}
                //    name = idString + s.name + privateId;
                //    name = s.name + "_" + privateId + "_" + idString;
                //    //if (child)
                //    //{
                //    //    name = name + privateId;
                //    //}
                //    CurveExport nodeCurve = s;
                //    if (string.IsNullOrEmpty(name))
                //    {
                //        return;
                //    }

                //    List<XNode.Node> connectedNodes = new List<XNode.Node>();
                //    foreach (var inputPort in nodeCurve.Inputs)
                //    {
                //        if (inputPort.fieldName == "Sliders")
                //        {
                //            // Iterate through the connected output ports
                //            foreach (var connection in inputPort.GetConnections())
                //            {
                //                // Retrieve the connected node
                //                var connectedNode = connection.node;
                //                connectedNodes.Add(connectedNode);
                //            }
                //        }
                //    }
                //    Color c = nodeCurve.colour;
                //    float thickness;
                //    try
                //    {
                //        thickness = nodeCurve.thickness[0];
                //    }
                //    catch { thickness = 5f; }

                //    var existingObject = GameObject.Find(name);



                //    if (existingObject == null)
                //    {

                //        GameObject newObject = new GameObject(name);
                //        newObject.transform.SetParent(this.transform, false);
                //        ExportCurveComp exportCurveSlider;
                //        if (!newObject.TryGetComponent<ExportCurveComp>(out exportCurveSlider))
                //        {
                //            exportCurveSlider = newObject.AddComponent<ExportCurveComp>();
                //        }

                //        exportCurveSlider.sliders = connectedNodes;


                //        for (int i = 0; i < curves.Count; i++)
                //        {
                //            GameObject newChildObject = new GameObject(name);
                //            newChildObject.transform.SetParent(newObject.transform, false);
                //            newChildObject.transform.parent = newObject.transform;

                //            LineRenderer curveFilterChildren = newChildObject.AddComponent<LineRenderer>();


                //            Vector3[] curvePoints;

                //            if (curves[i].type == 1)
                //            {
                //                curvePoints = Curves.bezier.generateBezier(curves[i].ControlPoints, 40, false);
                //            }
                //            else
                //            {
                //                curvePoints = curves[i].ControlPoints;
                //            }
                //            var curvePointsUpdated = new Vector3[curvePoints.Length];
                //            if (positionBinde)
                //            {

                //                for (int n = 0; n < curvePoints.Length; n++)
                //                {
                //                    curvePointsUpdated[n] = TransformPointWithRotationAndScale(curvePoints[n], newChildObject.transform);

                //                }
                //            }
                //            else
                //            {
                //                curvePointsUpdated = curvePoints;
                //            }

                //            curveFilterChildren.material = new Material(Shader.Find("Particles/Standard Unlit"));

                //            curveFilterChildren.startColor = c;
                //            curveFilterChildren.endColor = c;
                //            curveFilterChildren.startWidth = thickness;
                //            curveFilterChildren.endWidth = thickness;

                //            curveFilterChildren.positionCount = (curvePointsUpdated.Length);
                //            curveFilterChildren.numCapVertices = 1;
                //            curveFilterChildren.SetPositions(curvePointsUpdated);

                //            MoveLineRendererWithTransform moveCurve;
                //            if (!newChildObject.TryGetComponent<MoveLineRendererWithTransform>(out moveCurve))
                //            {
                //                moveCurve = newChildObject.AddComponent<MoveLineRendererWithTransform>();
                //            }

                //        }


                //    }

                //    else
                //    {
                //        ExportCurveComp exportCurveSlider;
                //        if (existingObject.TryGetComponent<ExportCurveComp>(out exportCurveSlider))
                //        {
                //            exportCurveSlider.sliders = connectedNodes;
                //        }
                //        else
                //        {
                //            exportCurveSlider = existingObject.AddComponent<ExportCurveComp>();
                //            exportCurveSlider.sliders = connectedNodes;
                //        }
                //        // ExportCurveComp exportCurveSlider = existingObject.GetComponent<ExportCurveComp>();

                //        Transform[] children = existingObject.GetComponentsInChildren<Transform>();

                //        exportCurveSlider.sliders = connectedNodes;


                //        if (curves != null)
                //        {

                //            if (curves.Count > 0)
                //            {


                //                if (curves.Count == children.Length - 1)
                //                {

                //                    for (int i = 0; i < curves.Count; i++)
                //                    {
                //                        LineRenderer linerenderer = children[i + 1].gameObject.GetComponent<LineRenderer>();

                //                        Vector3[] curvePoints;
                //                        if (curves[i].type == 1)
                //                        {
                //                            curvePoints = Curves.bezier.generateBezier(curves[i].ControlPoints, 40, false);
                //                        }
                //                        else
                //                        {
                //                            curvePoints = curves[i].ControlPoints;
                //                        }
                //                        MoveLineRendererWithTransform moveCurve;
                //                        if (!children[i + 1].TryGetComponent<MoveLineRendererWithTransform>(out moveCurve))
                //                        {
                //                            moveCurve = children[i + 1].AddComponent<MoveLineRendererWithTransform>();
                //                        }
                //                        var curvePointsUpdated = new Vector3[curvePoints.Length];

                //                        if (positionBinde)
                //                        {

                //                            for (int n = 0; n < curvePoints.Length; n++)
                //                            {
                //                                curvePointsUpdated[n] = TransformPointWithRotationAndScale(curvePoints[n], children[i + 1].transform);

                //                            }
                //                        }
                //                        else
                //                        {
                //                            curvePointsUpdated = curvePoints;
                //                        }
                //                        moveCurve.initialPositions = curvePoints;


                //                        linerenderer.material = new Material(Shader.Find("Particles/Standard Unlit"));
                //                        linerenderer.startColor = c;
                //                        linerenderer.endColor = c;
                //                        linerenderer.startWidth = thickness;
                //                        linerenderer.endWidth = thickness;
                //                        linerenderer.numCapVertices = 1;
                //                        linerenderer.positionCount = (curvePointsUpdated.Length);
                //                        linerenderer.SetPositions(curvePointsUpdated);

                //                    }
                //                }
                //                else
                //                {
                //                    if (curves.Count > children.Length - 1)
                //                    {
                //                        newExportCurve(ref existingObject, c, ref curves, ref children, thickness, name);

                //                    }
                //                    else
                //                    {
                //                        removeExportCurve(ref children, ref curves, ref existingObject);
                //                        //MoveLineRendererWithTransform test;
                //                        //if (children[children.Length - 1].TryGetComponent<MoveLineRendererWithTransform>(out test))
                //                        //{
                //                        //    DestroyImmediate(test);
                //                        //}
                //                        //DestroyImmediate(children[children.Length - 1].gameObject);
                //                    }

                //                }

                //            }
                //        }



                //    }
                //}

                //___________________________________________________________________________________


            }


        }
        //public void removeMeshExport(ref Transform[] children, ref List<Mesh> meshes)
        //{
        //    DestroyImmediate(children[children.Length - 1].gameObject);
        //    if (meshes.Count < children.Length - 1)
        //    {
        //        removeMeshExport(ref children, ref meshes);
        //    }
        //}
        //public void newExportMesh(ref GameObject existingObject, ref List<Mesh> meshes, ref Transform[] children, string realname, Color c)
        //{



        //    GameObject newChildObject = new GameObject(realname);
        //    newChildObject.transform.parent = existingObject.transform;

        //    MeshFilter meshFilter = newChildObject.AddComponent<MeshFilter>();
        //    MeshRenderer meshRenderer = newChildObject.AddComponent<MeshRenderer>();
        //    Mesh transformedMesh = Instantiate(meshes[meshes.Count - 1]);
        //    Vector3[] vertices = transformedMesh.vertices;


        //    transformedMesh.SetVertices(vertices);
        //    meshFilter.mesh = transformedMesh;
        //    meshRenderer.sharedMaterial = new Material(Shader.Find("Standard"));
        //    meshRenderer.sharedMaterial.color = c;

        //    if (meshes.Count > children.Length - 1)
        //    {
        //        newExportMesh(ref existingObject, ref meshes, ref children, realname, c);
        //    }
        //}
        //#endregion
        //public void newExportCurve(ref GameObject existingObject, Color c, ref List<Curve> curves, ref Transform[] children, float thickness, string Realname)
        //{
        //    GameObject newChildObject = new GameObject(Realname);
        //    if (existingObject == null) { return; }
        //    newChildObject.transform.SetParent(existingObject.transform, false);
        //    newChildObject.transform.parent = existingObject.transform;


        //    LineRenderer curveFilterChildren = newChildObject.AddComponent<LineRenderer>();
        //    Vector3[] curvePoints;
        //    if (curves[children.Length - 1].type == 1)
        //    {
        //        curvePoints = Curves.bezier.generateBezier(curves[children.Length - 1].ControlPoints, 40, false);
        //    }
        //    else
        //    {
        //        curvePoints = curves[children.Length - 1].ControlPoints;
        //    }

        //    var curvePointsUpdated = new Vector3[curvePoints.Length];
        //    if (positionBinde)
        //    {

        //        for (int n = 0; n < curvePoints.Length; n++)
        //        {
        //            curvePointsUpdated[n] = TransformPointWithRotationAndScale(curvePoints[n], children[children.Length - 1].transform);

        //        }
        //    }
        //    else
        //    {
        //        curvePointsUpdated = curvePoints;
        //    }
        //    curveFilterChildren.material = new Material(Shader.Find("Particles/Standard Unlit"));
        //    curveFilterChildren.startColor = c;
        //    curveFilterChildren.endColor = c;
        //    curveFilterChildren.startWidth = thickness;
        //    curveFilterChildren.endWidth = thickness;
        //    curveFilterChildren.positionCount = (curvePointsUpdated.Length);
        //    curveFilterChildren.numCapVertices = 1;
        //    curveFilterChildren.SetPositions(curvePointsUpdated);

        //    children = existingObject.GetComponentsInChildren<Transform>();
        //    if (curves.Count > children.Length - 1)
        //    {
        //        newExportCurve(ref existingObject, c, ref curves, ref children, thickness, Realname);
        //    }

        //}
        //public void removeExportCurve(ref Transform[] children, ref List<Curve> curves, ref GameObject existingObject)
        //{
        //    MoveLineRendererWithTransform test;
        //    if (children[children.Length - 1].TryGetComponent<MoveLineRendererWithTransform>(out test))
        //    {
        //        DestroyImmediate(test);
        //    }
        //    DestroyImmediate(children[children.Length - 1].gameObject);
        //    children = existingObject.GetComponentsInChildren<Transform>();
        //    if (curves.Count < children.Length - 1)
        //    {
        //        removeExportCurve(ref children, ref curves, ref existingObject);
        //    }
        //}wd
        public void PreviewOnOff(int id, ref string previewName, ref bool preview)
        {



            if (previewIds.Contains(id))
            {
                previewName = "Preview off";
                previewIds.Remove(id);

                preview = false;
            }
            else
            {
                previewName = "Preview On";
                previewIds.Add(id);

                preview = true;
            }

        }
        public void PreviewOnOffEnable(int id, ref string previewName, ref bool preview)
        {

            if (previewName == "Preview On")
            {
                preview = true;
                if (!previewIds.Contains(id))
                {
                    previewIds.Add(id);

                }
            }
            else
            {
                if (previewIds.Contains(id))
                {
                    previewIds.Remove(id);
                }
            }
        }
    }
}
//}