using System.Collections.Generic;
using UnityEngine;

namespace plugpea
{
    [CreateAssetMenu(fileName = "Data", menuName = "ScriptableObjects/MyDictionaryObject", order = 1)]
    public class namesAndPrivateIds : ScriptableObject
    {
        // Unity does not directly serialize dictionaries. We need to create two lists to simulate it.
        [SerializeField]
        private List<string> keys = new List<string>();

        [SerializeField]
        private List<string> values = new List<string>();

        public void Set(string key, string value)
        {
            int index = keys.IndexOf(key);
            if (index == -1)
            {
                keys.Add(key);
                values.Add(value);
            }
            else
            {
                values[index] = value;
            }
        }

        public bool TryGet(string key, out string value)
        {
            int index = keys.IndexOf(key);
            if (index == -1)
            {
                value = default;
                return false;
            }
            value = values[index];
            return true;
        }

        public void Clear()
        {
            keys.Clear();
            values.Clear();
        }
    }
}