using plugpea;
using System.Collections.Generic;
using Unity.VisualScripting;
using UnityEditor.Experimental.GraphView;
using UnityEngine;
using UnityEngine.UIElements;
using UnityEngine.Windows;
using XNode;
using Node = XNode.Node;


namespace PlugPeaNodes
{
    [NodeTint(51, 153, 204)]
    [CreateNodeMenu("Utility/Slider", 4)]
    [DontFold]
    public class Slider : InputNode
    {
        [HideInInspector]
        public GameObject currentGameobject;

        // The current value of the slider
        [HideInInspector]
        public float sliderValue;

        // Output port
        [HideInInspector]
        [Output] public List<float> outputValue;


        float LastSliderValue;
        //[HideInInspector]
        public float minValue = 0f;

        // Maximum value for the slider
        //[HideInInspector]
        public float maxValue = 1f;
        //[HideInInspector]
        public bool integer;
        [HideInInspector]
        public int intSliderValue;
        [HideInInspector]
        public bool Lock = false;
        List<float> outfloat;

        public override string GetString()
        {

            string name = "Slider";
            if (Lock)
            {
                name = null;
            }
            else
            {
                name = "Slider";
            }
            return name;
        }
        public delegate void InputValueChangedDelegate(Slider sourceNode);
        // Define an event of the delegate type.
        [HideInInspector]
        public bool foldoutInspector = false;

        protected override void Init()
        {
            base.Init();
            PlugPeaGraph gg = (PlugPeaGraph)this.graph;
            currentGameobject = gg.currentGameobject;
        }

        public override void Update()
        {
            base.Update();
            if (LastSliderValue != sliderValue)
            {
                LastSliderValue = sliderValue;
                OnInputValueChanged?.Invoke(this);
            }
        }
        public override void OnCreateConnection(NodePort from, NodePort to)
        {
            base.OnCreateConnection(from, to);
            this.GetValue(from);

        }

        public override void OnRemoveConnection(NodePort port)
        {
            base.OnRemoveConnection(port);
            this.GetValue(port);

        }
        public event InputValueChangedDelegate OnInputValueChanged;
        // Update the output value based on the slider value
        bool rename = false;


        public override object GetValue(NodePort port)
        {
            System.Type connectedPortType = null;


            // Get all connections to this port
            var connections = port.GetConnections();
            if (connections.Count > 0)
            {
                // Iterate over the connected ports
                foreach (NodePort connectedPort in connections)
                {
                    // Get the node this port belongs to
                    Node connectedNode = connectedPort.node;
                    if (rename == false && this.name == "Slider")
                    {
                        this.name = connectedPort.fieldName;
                    }
                    if(this.name != "Slider" && this.name != connectedPort.fieldName)
                    {
                        rename = true;
                    }
                    // Get the field name of the port on the connected node
                    string connectedPortName = connectedPort.fieldName;

                    // Get the data type of the port
                    connectedPortType = connectedPort.ValueType;

                }



                //if (connectedPortType.ToString() == "System.Collections.Generic.List`1[System.Int32]")
                //{ integer = true; }
                //else { integer = false; }
                ////intSliderValue = (int)sliderValue;
                outfloat = new List<float>() { sliderValue };
                if (integer)
                {
                    outfloat = new List<float>() {(int) sliderValue };

                    return outfloat;
                }
            }

            return outfloat;
        }
        public void SetValue(float values)
        {

            sliderValue = values;
        }


    }
}