using UnityEngine;
using XNode;
using static UnityEngine.GraphicsBuffer;
using static XNodeEditor.NodeEditor;
using XNodeEditor;
using System.Collections.Generic;
using System.Linq;
using Unity.VisualScripting;
using UnityEditor;
using Plane = PlugPeaNodes.Plane;
using PlugPeaNodes;
using plugpea;

namespace PlugPeaNodes {

    [CreateNodeMenu("PlugPea/Move", 1)]
    [DontFold]
    public class Move : BaseNode
    {

        [Input(ShowBackingValue.Never)] public object GeometryIn;
        [Input(ShowBackingValue.Never)] public List<Vector3> Vectors = new List<Vector3>() { new Vector3(0, 1f, 0) };
        [Output] public object GeometryOut;


        bool preview ;


        int id;

       PlugPeaGraph currentGraph;

    protected override void OnEnable()
        {
            base.OnEnable();
            id = GetInstanceID();

            //________________d
            currentGraph = (PlugPeaGraph)this.graph;
            var pp = currentGraph.getPlugPeaViaGUID();

            currentGraph.PreviewOnOffEnable(id, ref previewName, ref preview);
            currentGraph.UpdateNode(this);
 



        }
        // Override the Value method to process the input object
        protected override void Init()
        {
            base.Init();
            preview = true;
        }

        public override string GetString()
        {
            return "Draw";
        }
        [HideInInspector]
        public int inputType ; //0 for Plane , 1 for curve , 2 for Vector, 3 for mesh
        public override object GetValue(NodePort port)
        {
            var gg = (PlugPeaGraph)this.graph;


            

            var input = GetInputValue("GeometryIn", this.GeometryIn);
            List<Vector3> transformVectors = GetInputValue("Vectors", this.Vectors);
            //get balance the data input
            if (transformVectors != null && input != null)
            {
                int longestList = transformVectors.Count;
                if (input is List<object> listofinputs)
                {



                    if (listofinputs.Count > transformVectors.Count)
                    {
                        longestList = listofinputs.Count;
                    }



                    while (listofinputs.Count < longestList)
                    {
                        listofinputs.Add(listofinputs[listofinputs.Count - 1]);
                    }
                    if (transformVectors != null || transformVectors.Count == 0)
                    {


                        while (transformVectors.Count < longestList)
                        {
                            transformVectors.Add(transformVectors[transformVectors.Count - 1]);
                        }
                    }
                    else
                    {
                        while (transformVectors.Count < longestList)
                        {
                            transformVectors.Add(new Vector3(0, 1, 0));
                        }
                    }
                }
                if (input is List<PlugPeaNodes.Plane> PlaneListInput)
                {
                    inputType = 0;

                    if (PlaneListInput.Count > transformVectors.Count)
                    {
                        longestList = PlaneListInput.Count;
                    }



                    while (PlaneListInput.Count < longestList)
                    {
                        PlaneListInput.Add(PlaneListInput[PlaneListInput.Count - 1]);
                    }
                    if (transformVectors != null && transformVectors.Count != 0)
                    {

                        while (transformVectors.Count < longestList)
                        {
                            transformVectors.Add(transformVectors[transformVectors.Count - 1]);
                        }
                    }
                    else
                    {
                        while (transformVectors.Count < longestList)
                        {
                            transformVectors.Add(new Vector3(0, 1, 0));
                        }
                    }

                    //___________________________________________________________________
                    List<Plane> objects = new List<Plane>();

                    for (int i = 0; i < longestList; i++)
                    {
                        //Debug.Log(transformVectors[i].y);
                        Plane instancePlane = CreateInstance<Plane>();
                        instancePlane.basePoint = PlaneListInput[i].basePoint + transformVectors[i];
                        instancePlane.X = PlaneListInput[i].X;
                        instancePlane.Y = PlaneListInput[i].Y;
                        instancePlane.Normal = PlaneListInput[i].Normal;
                        //PlaneListInput[i].basePoint += transformVectors[i];
                        objects.Add(instancePlane);
                    }
                    return objects;
                }
                //______________________________________________________________________________________________________________________________

                if (input is List<Vector3> Vector3ListInput)
                {
                    //0 for Plane , 1 for curve , 2 for Vector, 3 for mesh
                    inputType = 2;

                    if (Vector3ListInput.Count > transformVectors.Count)
                    {
                        longestList = Vector3ListInput.Count;
                    }



                    while (Vector3ListInput.Count < longestList)
                    {
                        Vector3ListInput.Add(Vector3ListInput[Vector3ListInput.Count - 1]);
                    }
                    if (transformVectors != null && transformVectors.Count != 0)
                    {


                        while (transformVectors.Count < longestList)
                        {
                            transformVectors.Add(transformVectors[transformVectors.Count - 1]);
                        }
                    }
                    else
                    {
                        while (transformVectors.Count < longestList)
                        {
                            transformVectors.Add(new Vector3(0, 1, 0));
                        }
                    }

                    //ws

                    //___________________________________________________________________
                    List<Vector3> objects = new List<Vector3>();

                    for (int i = 0; i < longestList; i++)
                    {
                        objects.Add(Vector3ListInput[i] + transformVectors[i]);
                    }
                    return objects;
                }

                if (input is List<Curve> CurveListInput)
                {
                    //0 for Plane , 1 for curve , 2 for Vector, 3 for mesh
                    inputType = 1;
                    if (CurveListInput.Count > transformVectors.Count)
                    {
                        longestList = CurveListInput.Count;
                    }



                    while (CurveListInput.Count < longestList)
                    {
                        CurveListInput.Add(CurveListInput[CurveListInput.Count - 1]);
                    }
                    if (transformVectors != null && transformVectors.Count != 0)
                    {


                        while (transformVectors.Count < longestList)
                        {
                            transformVectors.Add(transformVectors[transformVectors.Count - 1]);
                        }
                    }
                    else
                    {
                        while (transformVectors.Count < longestList)
                        {
                            transformVectors.Add(new Vector3(0, 1, 0));
                        }
                    }



                    //______________________________________________________________
                    List<Curve> objects = new List<Curve>();

                    for (int i = 0; i < longestList; i++)
                    {
                        var temp_Curve = CreateInstance<Curve>();

                        //check type and close
                        temp_Curve.closed = CurveListInput[i].closed;
                        temp_Curve.type = CurveListInput[i].type;


                        int len = CurveListInput[i].ControlPoints.Count();
                        //  Debug.Log(len);


                        temp_Curve.ControlPoints = new Vector3[len];

                        if (temp_Curve.type != 2)
                        {
                            for (int j = 0; j < len; j++)
                            {
                                temp_Curve.ControlPoints[j] = CurveListInput[i].ControlPoints[j] + transformVectors[i];
                            }
                        }


                        else
                        {
                            for (int j = 0; j < len; j++)
                            {
                                temp_Curve.ControlPoints[j] = CurveListInput[i].ControlPoints[j] + transformVectors[i];
                            }
                            // Debug.Log("say");
                            Plane instancePlane = CreateInstance<PlugPeaNodes.Plane>();
                            instancePlane.basePoint = CurveListInput[i].center.basePoint;
                            instancePlane.X = CurveListInput[i].center.X;
                            instancePlane.Y = CurveListInput[i].center.Y;

                            temp_Curve.center = instancePlane;
                            temp_Curve.radius = CurveListInput[i].radius;
                            temp_Curve.center.basePoint += transformVectors[i];

                        }
                        objects.Add(temp_Curve);
                    }


                    return objects;


                }

                if (input is List<Mesh> MeshListInput)
                {
                    //0 for Plane , 1 for curve , 2 for Vector, 3 for mesh
                    inputType = 3;
                    if (MeshListInput.Count > transformVectors.Count)
                    {
                        longestList = MeshListInput.Count;
                    }

                    if (MeshListInput.Count > 0 && transformVectors.Count > 0)
                    {

                        while (MeshListInput.Count < longestList)
                        {
                            MeshListInput.Add(MeshListInput[MeshListInput.Count - 1]);
                        }
                        if (transformVectors != null || transformVectors.Count == 0)
                        {


                            while (transformVectors.Count < longestList)
                            {
                                transformVectors.Add(transformVectors[transformVectors.Count - 1]);
                            }
                        }
                        else
                        {
                            while (transformVectors.Count < longestList)
                            {
                                transformVectors.Add(new Vector3(0, 1, 0));
                            }
                        }
                    }

                    //we

                    //___________________________________________________________________
                    List<Mesh> objects = new List<Mesh>();

                    for (int i = 0; i < longestList; i++)
                    {
                        Mesh tempMesh = new Mesh();
                        Vector3[] vertices = MeshListInput[i].vertices;

                        for (int k = 0; k < MeshListInput[i].vertexCount; k++)
                        {
                            vertices[k] += transformVectors[i];
                        }

                        // tempMesh.vertices = vertices;
                        tempMesh.vertices = (vertices);
                        //tempMesh.SetTriangles( MeshListInput[i].triangles, 1);
                        tempMesh.triangles = MeshListInput[i].triangles;
                        //tempMesh.RecalculateNormals();
                        tempMesh.RecalculateNormals();
                        //tempMesh.RecalculateTangents();
                        objects.Add(tempMesh);
                    }
                    return objects;
                }
                else
                {
                    //Debug.Log("Im not in");
                    return null;
                }
            }
            else
            {
                return null;
            }

        }

        private void OnDestroy()
        {
            PlugPeaGraph gg = (PlugPeaGraph)this.graph;
            PlugPea pp = gg.getPlugPeaViaGUID();
            if (pp.curveDictPreview.ContainsKey(id)) { pp.curveDictPreview.Remove(id); }
            if (pp.pointDictPreview.ContainsKey(id)) { pp.pointDictPreview.Remove(id); }
            if (pp.meshDictPreview.ContainsKey(id)) { pp.meshDictPreview.Remove(id); }
            if (pp.planeDictPreview.ContainsKey(id)) { pp.planeDictPreview.Remove(id); }
        }
        public override void OnCreateConnection(NodePort from, NodePort to)
        {
            base.OnCreateConnection(from, to);
            PlugPeaGraph gg = (PlugPeaGraph)this.graph;
            gg.UpdateAndPropogate(this);
        }

        public override void OnRemoveConnection(NodePort port)
        {
            base.OnRemoveConnection(port);
            PlugPeaGraph gg = (PlugPeaGraph)this.graph;
            gg.UpdateAndPropogate(this);

        }

        [HideInInspector]
        public string previewName = "Preview On";
        public void OnClickButton()
        {
            currentGraph.PreviewOnOff(id, ref previewName, ref preview);
            currentGraph.UpdateNode(this);
          

        }

    }



    [CustomNodeEditor(typeof(Move))]
    public class MoveNodeEditor : NodeEditor
    {
        public override void OnBodyGUI()
        {
            base.OnBodyGUI();
            Move node = target as Move;

            NodeEditorGUILayout.PortField(new GUIContent("Geometry"), node.GetPort("GeometryIn"));
            NodeEditorGUILayout.PortField(new GUIContent("Geometry"), node.GetPort("GeometryOut"));
            if (GUILayout.Button(node.previewName))
            {
                //Debug.Log("pressed");
                node.OnClickButton();


            }
        }
    }
}