using JetBrains.Annotations;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using XNode;
using plugpea;
namespace PlugPeaNodes
{
    [CreateNodeMenu("PlugPea/Add (Number)", 2)]
    [DontFold]
    public class Addition : BaseNode
    {
        // Start is called before the first frame update
        [Input(ShowBackingValue.Never)] public List<float> a;
        [Input(ShowBackingValue.Never)] public List<float> b;


        [Output(ShowBackingValue.Never)] public List<float> result;
        protected override void Init()
        {
            base.Init();
        }
        public override object GetValue(NodePort port)
        {

            var a = GetInputValue<List<float>>("a", this.a);
            var b = GetInputValue<List<float>>("b", this.b);


            int maxLength = utils.GetLongestListLength(a, b);
            List<float> res = new List<float>();
            for (int i = 0; i < maxLength; i++)
            {
                res.Add(a[i] + b[i]);
            }

            return res;
        }
    }
}