using JetBrains.Annotations;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using XNode;
using plugpea;
namespace PlugPeaNodes
{
    [CreateNodeMenu("PlugPea/Divide (Number)", 2)]
    [DontFold]
    public class Division : BaseNode
    {
        // Start is called before the first frame update
        [Input(ShowBackingValue.Never)] public List<float> a;
        [Input(ShowBackingValue.Never)] public List<float> b;


        [Output(ShowBackingValue.Never)] public List<float> result;

        protected override void Init()
        {
            base.Init();
        }
        public override object GetValue(NodePort port)
        {

            var aa = GetInputValue<List<float>>("a", this.a);
            var bb = GetInputValue<List<float>>("b", this.b);


            int maxLength = utils.GetLongestListLength(aa, bb);
            List<float> res = new List<float>();
            for (int i = 0; i < maxLength; i++)
            {
                res.Add(aa[i] / bb[i]);
            }

            return res;
        }
    }
}