
using plugpea;
using System.Collections.Generic;
using UnityEngine;
using XNode;
namespace PlugPeaNodes
{
    [CreateNodeMenu("PlugPea/Modules (Number)", 2)]
    [DontFold]
    public class Modules : BaseNode
    {
        // Start is called before the first frame update
        [Input(ShowBackingValue.Never)] public List<float> a;
        [Input(ShowBackingValue.Never)] public List<float> b;


        [Output(ShowBackingValue.Never)] public List<float> result;

        protected override void Init()
        {
            base.Init();
        }

        public override void OnRemoveConnection(NodePort port)
        {
            base.OnRemoveConnection(port);
            this.GetValue(port);

        }

        public override void OnCreateConnection(NodePort from, NodePort to)
        {
            base.OnCreateConnection(from, to);
            this.GetValue(from);
        }

        public override string GetString()
        {
            return "Draw";
        }
        public override object GetValue(NodePort port)
        {

            var aa = utils.InsetMultiConnections(GetInputValues<List<float>>("a", this.a));
            var bb = utils.InsetMultiConnections(GetInputValues<List<float>>("b", this.b));

            if (aa == null || aa.Count == 0)
            {
                aa = new List<float>() { 1f };
            }
            if (bb == null || bb.Count == 0)
            {
                bb = new List<float>() { 1f };
            }
            int maxLength = utils.GetLongestListLength(aa, bb);
            List<float> res = new List<float>();
            for (int i = 0; i < maxLength; i++)
            {
                res.Add(aa[i] % bb[i]);
            }

            return res;
        }
    }
}