using System.Collections;
using System.Collections.Generic;

using System.Numerics;
using Unity.VisualScripting;
using UnityEngine;
using XNode;
using plugpea;
namespace PlugPeaNodes
{
    [CreateNodeMenu("PlugPea/Random (Number)", 4)]
    [DontFold]
    public class RandomNumber : BaseNode
    {
        [Input(ShowBackingValue.Never)]
        public List<float> Min; // Input list of planes


        [Input(ShowBackingValue.Never)]
        public List<float> Max; // Input list of radii

        [Input(ShowBackingValue.Never)]
        public List<float> seed; // Input list of radii

        [Input(ShowBackingValue.Never)]
        public List<float> Count; // Input list of radii

        [Output] public List<float> random;

        protected override void Init()
        {
            base.Init();


        }
        public override void OnCreateConnection(NodePort from, NodePort to)
        {
            base.OnCreateConnection(from, to);
            PlugPeaGraph gg = (PlugPeaGraph)this.graph;
            gg.UpdateAndPropogate(this);

        }

        public override void OnRemoveConnection(NodePort port)
        {
            base.OnRemoveConnection(port);
            PlugPeaGraph gg = (PlugPeaGraph)this.graph;
            gg.UpdateAndPropogate(this);

        }
        public override string GetString()
        {
            return "Draw";
        }
        public override object GetValue(NodePort port)
        {
            
            Min = utils.InsetMultiConnections(GetInputValues<List<float>>("Min", this.Min));

            Max = utils.InsetMultiConnections(GetInputValues<List<float>>("Max", this.Max));

            seed =  utils.InsetMultiConnections(GetInputValues<List<float>>("seed", this.seed));

            Count = utils.InsetMultiConnections(GetInputValues<List<float>>("Count", this.Count));
 
            if (Min==null || Min.Count == 0)
            {
                Min = new List<float>() { 0f };
            }
            if(Max == null || Max.Count == 0)
            {
                Max = new List<float>() { 1f };

            }
            if(seed ==null || seed.Count == 0)
            {
                seed = new List<float>() { 0f };
            }
            if(Count==null || Count.Count == 0)
            {
                Count = new List<float>() { 1f };
            }
            var longestList = Count[0];

            //Debug.Log(Count[0] + "Count");
            //Debug.Log(Min.Count + "Min");
            //Debug.Log(Max.Count + "Max");
            //Debug.Log(seed.Count + "seed");
          // Find the longest list length




         
            Random.InitState((int)seed[0]);
            List<float> randomNum = new List<float>();
            randomNum.Clear();
            for (int i = 0; i < longestList; i++)
            {
                var num = Random.Range(Min[0], Max[0]);
                randomNum.Add(num);
            }

            return randomNum;
        }
    }
}
