using JetBrains.Annotations;
using plugpea;
using System.Collections;
using System.Collections.Generic;
using Unity.VisualScripting;
using UnityEngine;
using XNode;
namespace PlugPeaNodes
{
    [CreateNodeMenu("PlugPea/Range", 2)]
    [DontFold]
    public class Range : BaseNode
    {
        // Start is called before the first frame update
        [Input(ShowBackingValue.Never)] public List<float> Min;
        [Input(ShowBackingValue.Never)] public List<float> Max;

        [Input(ShowBackingValue.Never)] public List<float> Steps;

        [Output] public List<float> range;
        PlugPea pp;
        GameObject currentGameobject;
        protected override void Init()
        {
            base.Init();
            var gg = (PlugPeaGraph)this.graph;


            Min = new List<float>() { 0f };
            Max = new List<float>() { 1f };
            Steps = new List<float>() { 10 };
        }

        PlugPeaGraph currentGraph;
         int id;
        protected override void OnEnable()
        {
            base.OnEnable();
            id = GetInstanceID();
            currentGraph = (PlugPeaGraph)this.graph;
            currentGraph.UpdateNode(this);
        }
        public override void OnCreateConnection(NodePort from, NodePort to)
        {
            base.OnCreateConnection(from, to);
            PlugPeaGraph gg = (PlugPeaGraph)this.graph;
            gg.UpdateAndPropogate(this);

        }

        public override void OnRemoveConnection(NodePort port)
        {
            base.OnRemoveConnection(port);
            PlugPeaGraph gg = (PlugPeaGraph)this.graph;
            gg.UpdateAndPropogate(this);
        }

        public override object GetValue(NodePort port)
        {

            List<float> Min = GetInputValue<List<float>>("Min", this.Min);
            List<float> Max = GetInputValue<List<float>>("Max", this.Max);
            List<float> Steps = GetInputValue<List<float>>("Steps", this.Steps);


            List<float> numbers = new List<float>();

            if (Steps != null && Min != null && Max != null)
            {
                numbers = GenerateSteps(Min[0], Max[0], Steps[0]);
            }
            else { numbers = new List<float>() { 0 }; }
            return numbers;
        }

        public override string GetString()
        {
            return "Draw";
        }
        public static List<float> GenerateSteps(float minVal, float maxVal, float numSteps)
        {
            float stepSize = (maxVal - minVal) / (numSteps - 1);
            List<float> numberss = new List<float>();

            for (int i = 0; i < (int)numSteps; i++)
            {
                float num = minVal + i * stepSize;
                numberss.Add(num);
            }

            return numberss;
        }
    }
}