using plugpea;
using System.Collections;
using System.Collections.Generic;
using Unity.VisualScripting;
using UnityEngine;
using XNode;
using XNodeEditor;

namespace PlugPeaNodes
{
    [CreateNodeMenu("PlugPea/Repeat Data", 2)]

    [DontFold]
    public class RepeatData : BaseNode
    {
        [Input(ShowBackingValue.Never)] public object anything;
        [Input(ShowBackingValue.Never)] public List<float> count;
        [Output] public object repeated;
        public override object GetValue(NodePort port)
        {






            var input = GetInputValues("anything", this.anything);
            

            List<float> count = GetInputValue<List<float>>("count", this.count);
            int longestList = (int)count[0];
            if (input[0] is List<PlugPeaNodes.Plane> )
            {
                List<Plane> PlaneListInput = new List<Plane>();
                for(int i = 0; i < input.Length; i++)
                {
                    if (input[i] is List<Plane> planess) {
                        for (int j = 0; j < planess.Count; j++)
                        {
                            PlaneListInput.Add(planess[j]);
                        }
                    }
                }
                List<Plane> planes = new List<Plane>();
                for (int i = 0; i < longestList; i++)
                {
                    planes.Add(PlaneListInput[i % PlaneListInput.Count]);
                }
                return planes;

            }
            else if(input[0] is List<float> )
            {
                List<float> floatListInput = new List<float>();
                for (int i = 0; i < input.Length; i++)
                {
                    if (input[i] is List<float> planess)
                    {
                        for (int j = 0; j < planess.Count; j++)
                        {
                            floatListInput.Add(planess[j]);
                        }
                    }
                }
                List<float> floates = new List<float>();
                for (int i = 0; i < longestList; i++)
                {
                    floates.Add(floatListInput[i % floatListInput.Count]);
                }
                return floates;
            }

            else if (input[0] is List<Vector3> )
            {
                List<Vector3> vectorListInput = new List<Vector3>();
                for (int i = 0; i < input.Length; i++)
                {
                    if (input[i] is List<Vector3> planess)
                    {
                        for (int j = 0; j < planess.Count; j++)
                        {
                            vectorListInput.Add(planess[j]);
                        }
                    }
                }
                List<Vector3> vectors = new List<Vector3>();
                for (int i = 0; i < longestList; i++)
                {
                    vectors.Add(vectorListInput[i % vectorListInput.Count]);
                }
                return vectors;
            }
            else if (input[0] is List<Mesh> )
            {
                List<Mesh> meshListInput = new List<Mesh>();
                for (int i = 0; i < input.Length; i++)
                {
                    if (input[i] is List<Mesh> planess)
                    {
                        for (int j = 0; j < planess.Count; j++)
                        {
                            meshListInput.Add(planess[j]);
                        }
                    }
                }
                List<Mesh> meshes = new List<Mesh>();
                for (int i = 0; i < longestList; i++)
                {
                    meshes.Add(meshListInput[i % meshListInput.Count]);
                }
                return meshes;
            }
            else if (input[0] is List<Curve> )
            {
                List<Curve> curveListInput = new List<Curve>();
                for (int i = 0; i < input.Length; i++)
                {
                    if (input[i] is List<Curve> planess)
                    {
                        for (int j = 0; j < planess.Count; j++)
                        {
                            curveListInput.Add(planess[j]);
                        }
                    }
                }
                List<Curve> curves = new List<Curve>();
                for (int i = 0; i < longestList; i++)
                {
                    curves.Add(curveListInput[i % curveListInput.Count]);
                }
                return curves;
            }
            else
            {
                return null;
            }
        }
        public object ConvertToObject(object[] inputArray)
        {
            ObjectContainer container = new ObjectContainer(inputArray);
            return container;
        }
    }
    [CustomNodeEditor(typeof(RepeatData))]
    public class repeatdataEditor : NodeEditor
    {
        public override void OnBodyGUI()
        {
            base.OnBodyGUI();
            RepeatData node = target as RepeatData;

            NodeEditorGUILayout.PortField(new GUIContent("anything"), node.GetPort("anything"));
            NodeEditorGUILayout.PortField(new GUIContent("repeated"), node.GetPort("repeated"));

        }
    }
    public class ObjectContainer
    {
        public object[] Data { get; private set; }

        public ObjectContainer(object[] data)
        {
            Data = data;
        }
    }
}
