using plugpea;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

using XNode;

namespace PlugPeaNodes{
    [CreateNodeMenu("PlugPea/Series", 2)]

    [DontFold]
public class Series : BaseNode
{
    // Start is called before the first frame update
    [Input(ShowBackingValue.Never)] public List<float>  Start;
    [Input(ShowBackingValue.Never)] public List<float>  Steps;
    [Input(ShowBackingValue.Never)] public List<float>    Count ;

    [Output] public List<float> series;


    PlugPea pp;


    protected override void Init()
    {
        base.Init();





        Count = new List<float>() { 10 };
        Steps = new List<float>() { 1f };
        Start = new List<float>() { 0f };
    }

     PlugPeaGraph currentGraph;
     int id;
    protected override void OnEnable()
    {
        base.OnEnable();
        id = GetInstanceID();
        currentGraph = (PlugPeaGraph)this.graph;
        currentGraph.UpdateNode(this);
    }
    public override void OnCreateConnection(NodePort from, NodePort to)
    {
        base.OnCreateConnection(from, to);
        PlugPeaGraph gg = (PlugPeaGraph)this.graph;
        gg.UpdateAndPropogate(this);

    }

    public override void OnRemoveConnection(NodePort port)
    {
        base.OnRemoveConnection(port);
        PlugPeaGraph gg = (PlugPeaGraph)this.graph;
        gg.UpdateAndPropogate(this);
    }
        public override object GetValue(NodePort port)
    {
        var gg = (PlugPeaGraph)this.graph;


        List<float> Start = GetInputValue<List<float>>("Start", this.Start);

        List<float> Steps = GetInputValue<List<float>>("Steps", this.Steps);

        List<float> Count = GetInputValue<List<float>>("Count", this.Count);


        List<float> numbers = new List<float>();

        if (Count!= null)
        {

            for (int i = 0; i < (int)Count[0]; i++)
            {
                numbers.Add(Start[0] + (Steps[0] * i));
            }

            return numbers;
        }
        else
        {
            return null;
        }
    }
}
}