using plugpea;
using System.Collections;
using System.Collections.Generic;
using Unity.VisualScripting.Antlr3.Runtime.Misc;
using Unity.VisualScripting;
using UnityEngine;
using XNode;

namespace PlugPeaNodes
{
    [CreateNodeMenu("PlugPea/Remap", 2)]

    [DontFold]
    public class reMap : BaseNode
    {
        PlugPeaGraph currentGraph;
        int id;
        // Start is called before the first frame update
        [Input(ShowBackingValue.Never)] public List<float> Value;
        [Input(ShowBackingValue.Never)] public List<float> Min;
        [Input(ShowBackingValue.Never)] public List<float> Max;

        [Output] public List<float> series;


        PlugPea pp;


        protected override void Init()
        {
            base.Init();
            Min = new List<float>() { 0f };
            Max = new List<float>() { 1f };

        }
        protected override void OnEnable()
        {
            base.OnEnable();
            id = GetInstanceID();
            currentGraph = (PlugPeaGraph)this.graph;
            currentGraph.UpdateNode(this);
        }
        public override void OnCreateConnection(NodePort from, NodePort to)
        {
            base.OnCreateConnection(from, to);
            PlugPeaGraph gg = (PlugPeaGraph)this.graph;
            gg.UpdateAndPropogate(this);

        }

        public override void OnRemoveConnection(NodePort port)
        {
            base.OnRemoveConnection(port);
            PlugPeaGraph gg = (PlugPeaGraph)this.graph;
            gg.UpdateAndPropogate(this);
        }
        public override object GetValue(NodePort port)
        {
            var gg = (PlugPeaGraph)this.graph;


            List<float> val = GetInputValue<List<float>>("Value", this.Value);

            List<float> min = GetInputValue<List<float>>("Min", this.Min);

            List<float> max = GetInputValue<List<float>>("Max", this.Max);

            float lowest = 9999999;
            float highest = -999999;
            for(int i = 0; i < val.Count; i++)
            {
                if(val[i] < lowest) { lowest = val[i]; }
                if (val[i] > highest) { highest = val[i]; }
            }
            List<float> newList = new List<float>();
            for(int i = 0; i < val.Count; i++)
            {
               newList.Add( utils.Remap(val[i], lowest, highest, min[0], max[0]));
            }
            return newList;

        }
    }
}