using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using XNode;
using Plane = PlugPeaNodes.Plane;
using PlugPeaNodes;
using plugpea;
namespace PlugPeaNodes
{
    [CreateNodeMenu("PlugPea/Deconstruct (Plane)", 3)]
    [DontFold]
    public class DeConstructPlane : BaseNode
    {
        // Start is called before the first frame update
        [Input(ShowBackingValue.Never, ConnectionType.Override)] public List<Plane> Planes;
        [Output] public Vector3 Point;
        [Output] public Vector3 X;
        [Output] public Vector3 Y;
        [Output] public Vector3 N;


        protected override void Init()
        {
            //Create a GUIStyle for the slider
            base.Init();

        }


        public override object GetValue(NodePort port)
        {

            var Planes = GetInputValue<List<Plane>>("Planes", this.Planes);
            if (Planes == null) { return null; }
            List<Vector3> pts = new List<Vector3>();
            List<Vector3> xs = new List<Vector3>();
            List<Vector3> ys = new List<Vector3>();
            List<Vector3> zs = new List<Vector3>();

            for (int i = 0; i < Planes.Count; i++)
            {
                pts.Add(Planes[i].basePoint);
                xs.Add(Planes[i].X);
                ys.Add(Planes[i].Y);
                zs.Add(Planes[i].Normal);
            }

            if (port.fieldName == "Point")
            {
                return pts;
            }

            else if (port.fieldName == "X")
            {
                return xs;
            }

            else if (port.fieldName == "Y")
            {
                return ys;
            }

            else if (port.fieldName == "N")
            {
                return zs;
            }
            else
            {
                return null;
            }
        }

    }
}