using System.Collections;
using System.Collections.Generic;
using System.Drawing;
using UnityEngine;
using XNode;
using plugpea;
namespace PlugPeaNodes
{
    [CreateNodeMenu("PlugPea/Deconstruct (Point)", 3)]
    [DontFold]
    public class DeConstructPoint : BaseNode
    {
        // Start is called before the first frame update
        [Input(ShowBackingValue.Never, ConnectionType.Override)] public List<Vector3> Points;

        [Output] public List<float> X;
        [Output] public List<float> Y;
        [Output] public List<float> Z;


        protected override void Init()
        {
            //Create a GUIStyle for the slider
            base.Init();
            X = new List<float>() { 0f };
            Y = new List<float>() { 0f };
            Z = new List<float>() { 0f };

        }


        public override object GetValue(NodePort port)
        {

            var Points = GetInputValue<List<Vector3>>("Points", this.Points);


            List<float> xs = new List<float>();
            List<float> ys = new List<float>();
            List<float> zs = new List<float>();

            for (int i = 0; i < Points.Count; i++)
            {

                xs.Add(Points[i].x);
                ys.Add(Points[i].y);
                zs.Add(Points[i].z);
            }


            if (port.fieldName == "X")
            {
                return xs;
            }

            else if (port.fieldName == "Y")
            {
                return ys;
            }

            else if (port.fieldName == "Z")
            {
                return zs;
            }
            else
            {
                return null;
            }
        }

    }
}