using System.Collections;
using System.Collections.Generic;
using System.Numerics;
using UnityEngine;
using UnityEngine.UIElements;
using XNode;
using static UnityEngine.GraphicsBuffer;
using Vector3 = UnityEngine.Vector3;
using plugpea;
namespace PlugPeaNodes
{
    [CreateNodeMenu("PlugPea/Distance", 4)]
    [DontFold]
    public class Distance : BaseNode
    {

        [Input(ShowBackingValue.Never, ConnectionType.Override)]
        public List<Vector3> A; // Input list of planes

        [Input(ShowBackingValue.Never, ConnectionType.Override)]
        public List<Vector3> B; // Input list of planes

        [Output] public List<float> Distances;
        public override object GetValue(NodePort port)
        {

            var As =utils.InsetMultiConnections( GetInputValues<List<Vector3>>("A", this.A));
            var Bs = utils.InsetMultiConnections(GetInputValues<List<Vector3>>("B", this.B));
            //  Lense = GetInputValue<List<float>>("Lense", this.Lense);

            int longestList = As.Count;
            if(Bs.Count> longestList)
            {
                longestList = Bs.Count;
            }
            while (As.Count < longestList)
            {
                As.Add(As[As.Count - 1]);
            }
            while (Bs.Count < longestList)
            {
                Bs.Add(Bs[Bs.Count - 1]);
            }
            List<float> disatnces = new List<float>();
            for(int i = 0; i < longestList; i++)
            {
                disatnces.Add(Vector3.Distance(As[i], Bs[i]));
            }

            return disatnces;
        }
    }
}
