using System.Collections.Generic;
using UnityEngine;
using XNode;
using PlugPeaNodes;
using Plane = PlugPeaNodes.Plane;
using XNodeEditor;
using plugpea;
using System.Numerics;
using Vector3 = UnityEngine.Vector3;

namespace PlugPeaNodes
{
    [CreateNodeMenu("PlugPea/Amplitude (Vector)", 4)]
    [DontFold]
    public class VectorAmplitude : BaseNode
    {

        [Input(ShowBackingValue.Never)] public List<Vector3> Vector;
        [Input(ShowBackingValue.Never)] public List<float> Size;
        [Output(ShowBackingValue.Never)] public List<Vector3> VectorOut;
        public override object GetValue(NodePort port)
        {
            Vector = utils.InsetMultiConnections(GetInputValues<List<Vector3>>("Vector", this.Vector));
            Size= utils.InsetMultiConnections(GetInputValues<List<float>>("Size", this.Size));

            int longestList = Mathf.Max(Vector.Count, Size.Count);
            while(Vector.Count < longestList)
            {
                Vector.Add(Vector[Vector.Count - 1]);
            }
            while (Size.Count < longestList)
            {
                Size.Add(Size[Size.Count - 1]);
            }
            List<Vector3> AmplifiedVector = new List<Vector3>();
            for (int i = 0; i < longestList; i++)
            {
                Vector[i].Normalize();
                AmplifiedVector.Add(Vector[i] * Size[i]);
           
            }

            return AmplifiedVector;
        }

    }
}