using System.Collections.Generic;
using UnityEngine;
using XNode;
using PlugPeaNodes;
using Plane = PlugPeaNodes.Plane;
using XNodeEditor;
using plugpea;
using System.Numerics;
using Vector3 = UnityEngine.Vector3;

namespace PlugPeaNodes
{
    [CreateNodeMenu("PlugPea/Vector From 2 Points (Point)", 4)]
    [DontFold]
    public class VectorFrom2Pt : BaseNode
    {

        [Input(ShowBackingValue.Never)] public List<Vector3> PointA;
        [Input(ShowBackingValue.Never)] public List<Vector3> PointB;
        [Output(ShowBackingValue.Never)] public List<Vector3> VectorOut;
        [Output(ShowBackingValue.Never)] public List<Vector3> Normilized;
        public override object GetValue(NodePort port)
        {
            PointA = utils.InsetMultiConnections(GetInputValues<List<Vector3>>("PointA", this.PointA));
            PointB = utils.InsetMultiConnections(GetInputValues<List<Vector3>>("PointB", this.PointB));
            //PointA = utils.InsetMultiConnections(GetInputValues<List<float>>("Size", this.Size));

            int longestList = Mathf.Max(PointA.Count, PointB.Count);
            while (PointA.Count < longestList)
            {
                PointA.Add(PointA[PointA.Count - 1]);
            }
            while (PointB.Count < longestList)
            {
                PointB.Add(PointB[PointB.Count - 1]);
            }
            List<Vector3> AmplifiedVector = new List<Vector3>();
            List<Vector3> NormalizedVectors = new List<Vector3>();
            for (int i = 0; i < longestList; i++)
            {
                
                AmplifiedVector.Add((PointB[i]- PointA[i]));
                NormalizedVectors.Add((PointB[i] - PointA[i]).normalized);

            }
            if (port.fieldName == "VectorOut")
            {
                return AmplifiedVector;
            }
            if (port.fieldName == "Normilized")
            {
                return NormalizedVectors;
            }
            else
            {
                return null;
            }
           
        }

    }
}