using plugpea;
using System.Collections;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using Unity.VisualScripting;
using UnityEngine;
using XNode;
using XNodeEditor;

namespace PlugPeaNodes
{
    [CreateNodeMenu("PlugPea/X (Vector)", 3)]
    [NodeWidth(150)]
    [DontFold]
    public class UnitXX : BaseNode
    {
        [Input(ShowBackingValue.Never)] public List<float> x;
        [Output(ShowBackingValue.Never)] public List<Vector3> Vector;
        PlugPeaGraph gg;
        PlugPea pp;
        GameObject currentGameobject;
        int id;
        PlugPeaGraph currentGraph;
        protected override void Init()
        {
            base.Init();
            var gg = (PlugPeaGraph)this.graph;

            currentGameobject = gg.currentGameobject;
            this.name = "Unit X";
            x = new List<float>() { 1f };
        }
        protected override void OnEnable()
        {
            base.OnEnable();
            id = GetInstanceID();
            currentGraph = (PlugPeaGraph)this.graph;
            var pp = currentGraph.getPlugPeaViaGUID();

            currentGraph.UpdateNode(this);
        }
        public override void OnCreateConnection(NodePort from, NodePort to)
        {
            base.OnCreateConnection(from, to);
            PlugPeaGraph gg = (PlugPeaGraph)this.graph;
            gg.UpdateAndPropogate(this);


        }

        public override void OnRemoveConnection(NodePort port)
        {
            base.OnRemoveConnection(port);
            PlugPeaGraph gg = (PlugPeaGraph)this.graph;
            gg.UpdateAndPropogate(this);

        }

        public override object GetValue(NodePort port)
        {

            List<float> xs = GetInputValue<List<float>>("x", this.x);
            List<Vector3> vectors = new List<Vector3>();
            for (int i = 0; i < xs.Count; i++)
            {
                vectors.Add(new Vector3(xs[i], 0, 0));
            }

            return vectors;
        }



    }


}
