using plugpea;
using System.Collections;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using UnityEngine;
using XNode;
using XNodeEditor;

namespace PlugPeaNodes
{
    [CreateNodeMenu("PlugPea/Y (Vector)", 3)]
    [NodeWidth(150)]
    [DontFold]
    public class UnitY : BaseNode
    {
        [Input(ShowBackingValue.Never)] public List<float> y;
        [Output] public List<Vector3> VectorOut;
        PlugPeaGraph gg;
        PlugPea pp;
        GameObject currentGameobject;
        int id;
        PlugPeaGraph currentGraph;
        protected override void Init()
        {
            base.Init();
        }

        protected override void OnEnable()
        {
            base.OnEnable();
            id = GetInstanceID();
            currentGraph = (PlugPeaGraph)this.graph;
            var pp = currentGraph.getPlugPeaViaGUID();

            currentGraph.UpdateNode(this);
        }
        public override object GetValue(NodePort port)
        {
            var gg = (PlugPeaGraph)this.graph;

            currentGameobject = gg.currentGameobject;


            List<float> ys = utils.InsetMultiConnections(GetInputValues<List<float>>("y", this.y));
            List<Vector3> vectors = new List<Vector3>();

            if (ys != null)
            {
                for (int i = 0; i < ys.Count; i++)
                {
                    vectors.Add(new Vector3(0, ys[i], 0));
                }
            }
            else
            {
                vectors.Add(new Vector3(0, 1, 0));
            }

            if (port.fieldName == "VectorOut")
            {
                return vectors;
            }
            else
            {
                return null;
            }
        }

        public override void OnCreateConnection(NodePort from, NodePort to)
        {
            base.OnCreateConnection(from, to);
            PlugPeaGraph gg = (PlugPeaGraph)this.graph;
            gg.UpdateAndPropogate(this);


        }

        public override void OnRemoveConnection(NodePort port)
        {
            base.OnRemoveConnection(port);
            PlugPeaGraph gg = (PlugPeaGraph)this.graph;
            gg.UpdateAndPropogate(this);

        }




    }


}