using plugpea;
using System.Collections;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using UnityEngine;
using XNode;
using static UnityEngine.GraphicsBuffer;
using static XNodeEditor.NodeEditor;
using XNodeEditor;

namespace PlugPeaNodes
{
    [CreateNodeMenu("PlugPea/Z (Vector)", 3)]
    [NodeWidth(150)]
    [DontFold]
    public class UnitZ : BaseNode
    {
        [Input(ShowBackingValue.Never)] public List<float> z;
        [Output(ShowBackingValue.Never)] public List<Vector3> Vector;
        PlugPeaGraph gg;
        PlugPea pp;
        GameObject currentGameobject;
        int id;
        PlugPeaGraph currentGraph;
        protected override void Init()
        {
            base.Init();
            z = new List<float>() { 1f };
            var gg = (PlugPeaGraph)this.graph;
        }
        protected override void OnEnable()
        {
            base.OnEnable();
            id = GetInstanceID();
            currentGraph = (PlugPeaGraph)this.graph;
            var pp = currentGraph.getPlugPeaViaGUID();

            currentGraph.UpdateNode(this);
        }
        public override void OnCreateConnection(NodePort from, NodePort to)
        {
            base.OnCreateConnection(from, to);
            PlugPeaGraph gg = (PlugPeaGraph)this.graph;
            gg.UpdateAndPropogate(this);


        }

        public override void OnRemoveConnection(NodePort port)
        {
            base.OnRemoveConnection(port);
            PlugPeaGraph gg = (PlugPeaGraph)this.graph;
            gg.UpdateAndPropogate(this);

        }
        public override object GetValue(NodePort port)
        {

            List<float> z = GetInputValue<List<float>>("z", this.z);
            List<Vector3> vectors = new List<Vector3>();
            for (int i = 0; i < z.Count; i++)
            {
                vectors.Add(new Vector3(0, 0, z[i]));
            }

            return vectors;
        }


    }



}