using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using XNode;
using UnityEditor;
using PlugPeaNodes;
using plugpea;
namespace PlugPeaNodes
{
    [CreateNodeMenu("PlugPea/Deconstruct (Circle)", 4)]
    [DontFold]
    public class DeConstructCircle : BaseNode
    {

        [Input(connectionType = ConnectionType.Multiple)] public List<Curve> circles;
        [Output] public List<float> radius;
        [Output] public List<Vector3> plane;
        int id;
        PlugPeaGraph currentGraph;
        protected override void Init()
        {
            base.Init();
        }
        protected override void OnEnable()
        {
            base.OnEnable();
            id = GetInstanceID();
            currentGraph = (PlugPeaGraph)this.graph;
            var pp = currentGraph.getPlugPeaViaGUID();
            currentGraph.UpdateNode(this);
        }

        public override object GetValue(NodePort port)
        {


            List<Curve> circle = GetInputValue("circles", this.circles);
            List<float> cuRadius = new List<float>();
            List<Vector3> center = new List<Vector3>();
            for (int i = 0; i < circle.Count; i++)
            {
                cuRadius.Add(circle[i].radius);
                center.Add(circle[i].center.basePoint);
            }

            if (port.fieldName == "radius")
            {
                return cuRadius;
            }

            if (port.fieldName == "plane")
            {
                return center;

            }

            else { return null; }
        }
    }
}