    using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using PlugPeaNodes;
using XNode;
using JetBrains.Annotations;
using plugpea;
namespace PlugPeaNodes
{
    [CreateNodeMenu("PlugPea/Deconstruct (Curve)", 4)]
    [DontFold]
    public class DeconstructCurve : BaseNode
    {

        // Start is called before the first frame update
        [Input(connectionType = ConnectionType.Multiple)] public List<Curve> curves;
        [Output] public List<Vector3> controlPoints;
        [Output] public List<bool> isPeriodic;
        [Output] public List<string> Type;

        public override object GetValue(NodePort port)
        {
            List<Curve> curves = utils.InsetMultiConnections(GetInputValues("curves", this.curves));
            List<Vector3> cPoints = new List<Vector3>();
            List<bool> periodic = new List<bool>();
            List<string> datatype = new List<string>();
            for (int i = 0; i < curves.Count; i++)
            {
                int curveTypeint = curves[i].type;
                if (curveTypeint == 0)
                {
                    datatype.Add("Polyline");

                }
                else if (curveTypeint == 1)
                {
                    datatype.Add("Bezier");
                }
                else
                {
                    datatype.Add("Circle");
                }
                periodic.Add(curves[i].closed);
                for (int j = 0; j < curves[i].ControlPoints.Length; j++)
                {
                    cPoints.Add(curves[i].ControlPoints[j]);
                }
            }
            if (port.fieldName == "controlPoints")
            {
                return cPoints;
            }
            else if (port.fieldName == "isPeriodic")
            {
                return periodic;
            }
            else if (port.fieldName == "Type")
            {
                return datatype;
            }
            else
            {
                return null;
            }
        }
    }
}