using System.Collections.Generic;
using UnityEngine;
using XNode;
using PlugPeaNodes;
using Plane = PlugPeaNodes.Plane;
using XNodeEditor;
using plugpea;
using System.Numerics;
using Vector3 = UnityEngine.Vector3;

namespace PlugPeaNodes
{
    [CreateNodeMenu("PlugPea/Deconstruct (Mesh)", 4)]
    [DontFold]
    public class DeconstructMesh : BaseNode
    {
        [Input(ShowBackingValue.Never)] public List<Mesh> mesh;
        [Output] public List<Vector3> Vertices;
        [Output] public List<int> Triangles;
        [Output] public List<Vector3> Normals;
        protected override void OnEnable()
        {
            base.OnEnable();


        }
        public override string GetString()
        {
            return "Draw";
        }
        public override object GetValue(NodePort port)
        {
            mesh = utils.InsetMultiConnections(GetInputValues<List<Mesh>>("mesh", mesh));

            List<Vector3> verticx = new List<Vector3>();
            List<int> ints = new List<int>();
            List<Vector3> normies = new List<Vector3>();
            for(int i = 0; i < mesh.Count; i++)
            {
                for(int j = 0; j < mesh[i].vertexCount; j++)
                {
                    verticx.Add(mesh[i].vertices[j]);
                    normies.Add(mesh[i].normals[j]);
                }

                for(int k = 0; k < mesh[i].triangles.Length; k++)
                {
                    ints.Add(mesh[i].triangles[k]);
                }
                
            }

            if (port.fieldName == "Vertices")
            {
                return verticx;
            }

            if (port.fieldName == "Triangles")
            {
                return ints;
            }
            if (port.fieldName == "Normals")
            {
                return normies;
            }
            return null;

        }
    }
}
