using System.Collections.Generic;
using UnityEngine;
using XNode;
using PlugPeaNodes;
using Plane = PlugPeaNodes.Plane;
using XNodeEditor;
using plugpea;
using System.Numerics;
using Vector3 = UnityEngine.Vector3;

namespace PlugPeaNodes
{
    [CreateNodeMenu("PlugPea/Subdivide (Mesh)", 4)]
    [DontFold]
    public class Subdivide : BaseNode
    {
        [Input(ShowBackingValue.Never)] public List<Mesh> mesh;
        [Input(ShowBackingValue.Never)] public List<float> level;
        [Output] public List<Mesh> Meshes;
        int id;
        bool preview;
        PlugPeaGraph currentGraph;
        [HideInInspector]
        public string previewName = "Preview On";
        protected override void OnEnable()
        {
            base.OnEnable();
            id = GetInstanceID();
            currentGraph = (PlugPeaGraph)this.graph;


            currentGraph.PreviewOnOffEnable(id, ref previewName, ref preview);
            currentGraph.UpdateNode(this);
        }
        // Update is called once per frame
        public override string GetString()
        {
            return "Draw";
        }

        
        public void OnClickButton()
        {
            PlugPeaGraph currentGraph = (PlugPeaGraph)this.graph;
            currentGraph.PreviewOnOff(id, ref previewName, ref preview);
        }
        private void OnDestroy()
        {

            PlugPeaGraph gg = (PlugPeaGraph)this.graph;
            PlugPea pp = gg.getPlugPeaViaGUID();
            if (pp.meshDictPreview.ContainsKey(id)) { pp.meshDictPreview.Remove(id); }
        }
        public override void OnCreateConnection(NodePort from, NodePort to)
        {
            base.OnCreateConnection(from, to);
            PlugPeaGraph gg = (PlugPeaGraph)this.graph;
            gg.UpdateAndPropogate(this);

        }
        private int[] subdivision = new int[] { 0, 2, 3, 4, 6, 8, 9, 12, 16, 18, 24 };
        public override void OnRemoveConnection(NodePort port)
        {
            base.OnRemoveConnection(port);
            PlugPeaGraph gg = (PlugPeaGraph)this.graph;
            gg.UpdateAndPropogate(this);

        }
        public override object GetValue(NodePort port)
        {
            mesh = utils.InsetMultiConnections(GetInputValues<List<Mesh>>("mesh", this.mesh));
            level = utils.InsetMultiConnections(GetInputValues<List<float>>("level", this.level));
            List<Mesh> meshOut = new List<Mesh>();
            if (level[0] <= 3)
            {
                for(int i = 0; i <  mesh.Count; i++)
                {
                    //Mesh tempMesh = ;
                    //tempMesh.RecalculateNormals();
                    // tempMesh.RecalculateBounds();
                    Mesh currentMesh = mesh[i];
                    currentMesh.vertices = mesh[i].vertices;
                    currentMesh.triangles = mesh[i].triangles;
                    //for (int k = 0; i < 2; k++)
                    //{
                    //    MeshHelper.Subdivide(currentMesh, subdivision[(int)level[0]]);
                    //}
                    
                    meshOut.Add(currentMesh);
                }
                return meshOut;
            }
            else
            {
                return null;
            }
        }


    }

    [CustomNodeEditor(typeof(Subdivide))]
    public class SubdivideMeshEditor : NodeEditor
    {
        public override void OnBodyGUI()
        {
            Subdivide cc = (Subdivide)target;
            base.OnBodyGUI();

            if (GUILayout.Button(cc.previewName))
            {
                //Debug.Log("pressed");
                cc.OnClickButton();


            }
        }

    }
}