using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using XNode;
using plugpea;
namespace PlugPeaNodes
{
    [CreateNodeMenu("PlugPea/Camera", 4)]
    [DontFold]
    public class CameraCrane : BaseNode
    {

        [Input(ShowBackingValue.Never, ConnectionType.Override)]
        public List<Vector3> Position; // Input list of planes


        [Input(ShowBackingValue.Never, ConnectionType.Override, connectionType = ConnectionType.Multiple)]
        public List<Vector3> Target; // Input list of radii


        [HideInInspector]
        public Camera cam;

        int id;
        PlugPeaGraph currentGraph;
       
        protected override void OnEnable()
        {
            base.OnEnable();
            id = GetInstanceID();
            currentGraph = (PlugPeaGraph)this.graph;
            var pp = currentGraph.getPlugPeaViaGUID();
            cam = GameObject.FindObjectOfType<Camera>();
            

            currentGraph.UpdateNode(this);


        }

        public override string GetString()
        {
            return "Draw";
        }
        protected override void Init()
        {
            base.Init();

            List<float> Lense = new List<float>() { 50f };
        }
        public override object GetValue(NodePort port)
        {

            Position = GetInputValue<List<Vector3>>("Position", this.Position);
            Target = GetInputValue<List<Vector3>>("Target", this.Target);
          //  Lense = GetInputValue<List<float>>("Lense", this.Lense);

            if (cam != null)
            {
                cam.transform.position = Position[0];
                cam.transform.LookAt(Target[0]);
         
            }
            else
            {
                cam = GameObject.FindObjectOfType<Camera>();
            }


            return null;
        }
    }

}
