using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using XNode;
using PlugPeaNodes;
using XNodeEditor;
using plugpea;
using UnityEditor;
using Unity.VisualScripting;
using System.Xml;

namespace PlugPeaNodes
{
    [CreateNodeMenu("Bake/Curve (Bake)" , 2)  ]
    [DontFold]
    public class CurveExport : BaseNode
    {
        [Input(ShowBackingValue.Never)] public List<Curve> Curve;
        [HideInInspector]
         public Color colour;
        [Input(ShowBackingValue.Never)] public List<float> Thickness;
        [Input(ShowBackingValue.Never)] public List<float> Sliders;
        public override string GetString()
        {
            return "ExportCurve";
        }

        [HideInInspector]
        public List<Curve> curves;
        [HideInInspector]
        public int id;
        PlugPea pp;
        string graphName;
        GameObject currentGameobject;
        [HideInInspector]
        public PlugPeaGraph currentGraph;
        string stringId;
        int cCount;
        protected override void OnEnable()
        {
            base.OnEnable();
            //if (cCount == 0)
            //{
            //    for (int i = 0; i < graph.nodes.Count; i++)
            //    {

            //        if (graph.nodes[i] == this)
            //        {
            //            cCount = i;
            //        }
            //    }
            //}

            //Debug.Log(cCount);
            //if (!PlayerPrefs.HasKey("CurveExportId"))
            //{
            //    id = GetInstanceID();
            //    PlayerPrefs.SetInt("CurveExportId", id);
            //}
            //id = PlayerPrefs.GetInt("CurveExportId", 0);
            if (string.IsNullOrEmpty(stringId))
            {
                id = GetInstanceID();
                stringId = id.ToString();
            }
            else
            {
                id = int.Parse(stringId);
            }
            currentGraph = (PlugPeaGraph)this.graph;
            //Debug.Log(id);
        }

        private void OnDestroy()
        {


        }


        public override void OnCreateConnection(NodePort from, NodePort to)
        {
            base.OnCreateConnection(from, to);
            PlugPeaGraph gg = (PlugPeaGraph)this.graph;
            gg.UpdateNode(this);

        }

        public override void OnRemoveConnection(NodePort port)
        {
            base.OnRemoveConnection(port);
            PlugPeaGraph gg = (PlugPeaGraph)this.graph;
            gg.UpdateNode(this);

        }
        [HideInInspector]
        public string previousName = null;

        protected override void Init()
        {
            base.Init();
            if (string.IsNullOrEmpty(previousName))
            {
                previousName = this.name;
            }

        }
        public Color GetColor()
        {
            return colour;
        }
        [HideInInspector]
        public List<Node> connectedNodes;
        [HideInInspector]
        public List<float> thickness;



        
        public override object GetValue(NodePort port)
        {
            string name = id.ToString();

            string idString = id.ToString();

            List<string> ids = currentGraph.childIDs;

            
            if (this.name != previousName)
            {
             
                GameObject existingObject;
                foreach (string pIds in ids)
                {
                    Debug.Log("it run's not the base name");
                    existingObject = GameObject.Find( previousName +"_"+ pIds+"_"+ idString);
                    if (existingObject != null)
                    {
                        Debug.Log("it was succesfull");
                        existingObject.name = this.name + "_" + pIds + "_" + idString;
                    }

                }


                previousName = this.name;


            }


            // radii = utils.InsetMultiConnections(GetInputValues<List<float>>("Radius", Radius));
            List<Curve> curves = utils.InsetMultiConnections(GetInputValues<List<Curve>>("Curve", this.Curve));


            //foreach (Curve crv in curves)
            //{
            //    crv = Curves.Transformation.Move(crv, transformVector);
            //}
            var colour = GetInputValue<Color>("colour", this.colour);

            thickness = utils.InsetMultiConnections(GetInputValues<List<float>>("Thickness", this.Thickness));



            if (port.fieldName == "Sliders")
            {

                connectedNodes = port.GetConnections().ConvertAll(connection => connection.node);
            }


            return curves;
        }

    }

    [CustomNodeEditor(typeof(CurveExport))]
    public class curveExportEditor : NodeEditor
    {
        public override void OnBodyGUI()
        {
            base.OnBodyGUI();

            EditorGUI.BeginChangeCheck();

            // Cast target to access your custom node's properties
            CurveExport node = (CurveExport)target;

            node.colour = EditorGUILayout.ColorField("Color", node.colour);

            if (EditorGUI.EndChangeCheck())
            {
                // If the color has changed, update the node
                node.currentGraph.UpdateNode(node);
            }
        }
    }

}

