using plugpea;
using System;
using System.Collections;
using System.Collections.Generic;
using UnityEditor;
using UnityEngine;
using XNode;
using XNodeEditor;
using static UnityEditor.GenericMenu;
namespace PlugPeaNodes
{
    [CreateNodeMenu("Bake/Mesh (Bake)" , 2)]
    [DontFold]
    public class MeshExport : BaseNode
    {
        // Start is called before the first frame update
        [Input(ShowBackingValue.Never)] public List<Mesh> mesh;

        [Input(ShowBackingValue.Never)] public List<float> Sliders;
        [HideInInspector]
        public Color colour;

        //public bool RigidBody;
        //public bool Collider;
        [Output] public List<object> outMesh;

        public override string GetString()
        {
            return "ExportMesh";
        }

        [HideInInspector]
        public List<Mesh> meshes;
        [HideInInspector]
        public int id;
        PlugPea pp;
        string graphName;
        GameObject currentGameobject;
        [HideInInspector]
        public string previousName = null;
        [HideInInspector]
        public PlugPeaGraph currentGraph;
        int cCount;
        string stringId;
        protected override void OnEnable()
        {
            base.OnEnable();
            //if (cCount == 0)
            //{
            //    for (int i = 0; i < graph.nodes.Count; i++)
            //    {

            //        if (graph.nodes[i] == this)
            //        {
            //            cCount = i;
            //        }
            //    }
            //}
            //if (!PlayerPrefs.HasKey("MeshExportId"))
            //{
            //    id = GetInstanceID();
            //    PlayerPrefs.SetInt("MeshExportId", id);wf
            //}
            //id = PlayerPrefs.GetInt("MeshExportId", 0);
            if (string.IsNullOrEmpty(stringId) & id == 0)
            {
                id = GetInstanceID();
                stringId = id.ToString();
            }
            else
            {
                if (id == 0)
                {
                    id = int.Parse(stringId);
                }
            }

            currentGraph = (PlugPeaGraph)this.graph;

        }

        public Color GetColor()
        {
            return colour;
        }


        public override object GetValue(NodePort port)
        {
            var meshes = utils.InsetMultiConnections( GetInputValues<List<Mesh>>("mesh", this.mesh));
            string name = id.ToString();

            string idString = id.ToString();
            //var baseName = idString.Substring(1, 3) + " Mesh Export";
            List<string> ids = currentGraph.childIDs;
            if (this.name != previousName)
            {

                GameObject existingObject;
                foreach (string pIds in ids)
                {
                    Debug.Log("it run's not the base name");
                    existingObject = GameObject.Find(previousName + "_" + pIds + "_" + idString);
                    
                    if (existingObject != null)
                    {
                        Debug.Log("it was succesfull");
                        existingObject.name = this.name + "_" + pIds + "_" + idString;
                        

                    }

                }

                previousName = this.name;



            }
            return meshes;
        }
        public override void OnCreateConnection(NodePort from, NodePort to)
        {
            base.OnCreateConnection(from, to);
            PlugPeaGraph gg = (PlugPeaGraph)this.graph;
            gg.UpdateNode(this);
        }

        public override void OnRemoveConnection(NodePort port)
        {
            base.OnRemoveConnection(port);
            PlugPeaGraph gg = (PlugPeaGraph)this.graph;
            gg.UpdateNode(this);

        }
        protected override void Init()
        {
            base.Init();
            if (string.IsNullOrEmpty(previousName))
            {
                previousName = this.name;
            }

        }

    }
    [CustomNodeEditor(typeof(MeshExport))]
    public class meshExportEditor : NodeEditor
    {
        public override void OnBodyGUI()
        {
            base.OnBodyGUI();

            EditorGUI.BeginChangeCheck();

            // Cast target to access your custom node's properties
            MeshExport node = (MeshExport)target;

            node.colour = EditorGUILayout.ColorField("Color", node.colour);

            if (EditorGUI.EndChangeCheck())
            {
                // If the color has changed, update the node
                node.currentGraph.UpdateNode(node);
            }
        }
    }
}
