using System.Collections;
using System.Collections.Generic;
using Unity.VisualScripting;
using UnityEngine;
using XNode;

namespace PlugPeaNodes
{
    [CreateNodeMenu("")]
    public class Plane : Node
    {

        // Start is called before the first frame update
        public Vector3 basePoint;
        public Vector3 X;
        public Vector3 Y;
        public Vector3 Normal;


        public Plane(Vector3 point, Vector3 xVector, Vector3 yVector)
        {
            basePoint = point;
            X = xVector;
            Y = yVector;

        }

        public static implicit operator Plane(Vector3 v)
        {
            return new Plane(v, Vector3.right, Vector3.up);
        }
        public Vector3 ClosestPointOnPlane(Vector3 point)
        {
            Vector3 offset = point - basePoint;
            float xProjection = Vector3.Dot(offset, X);
            float yProjection = Vector3.Dot(offset, Y);
            return basePoint + xProjection * X + yProjection * Y;
        }

    }


}